<Cabbage>
#define PLANT colour(76,130,180,155) outlinecolour(0,0,0,255) outlinethickness(2)
#define BASIC colour(56, 150, 180, 255) trackercolour(56,255,182,255) outlinecolour(17,37,37,155)
#define VBASIC colour("Gainsboro") trackercolour(56,255,182,255) outlinecolour(17,37,37,155)
#define FTABLES tablegridcolour("Silver") tablecolour:0(20,20,20,245) tablebackgroundcolour("Silver")
#define BUTTONS colour:0(79,79,79,105) colour:1("MediumTurquoise") colour:0("DarkSlateGrey") fontcolour("Gainsboro")
#define MIDI colour:0(96,150,170,255) colour:1("Grey") value(0) latched(0)
#define MIDIX colour:0(96,150,170,255) colour:1("red") value(0) latched(0) 
#define FONT fontcolour("Gainsboro")
#define RSLIDER colour(56, 150, 180, 255) trackercolour("MediumTurquoise") fontcolour("Gainsboro") valuetextbox(1) textboxcolour("black") 

form caption("ReSynthesizer") size(995,649) colour(76,130,180,155) outlinecolour(0,0,0,255) outlinethickness(2) pluginid("MVerb") fontcolour("white") style("legacy") 
keyboard bounds(6,557,840,85)

image bounds(5,5,245,250) plant("pvoc") $PLANT
{
filebutton bounds(70,5,165,25) channel("load") text("Load .pvx File") $BUTTONS
button bounds(5,5,50,25) channel("pvplay") text("Play") $BUTTONS
button bounds(70,38,30,15) text("Time") channel("mappointer") $MIDI
button bounds(100,38,9,15) text("") channel("mappointerX") $MIDIX
rslider bounds(60,55,60,45) channel("pointer") range(0,1,0,1,.0001) $RSLIDER
button bounds(130,38,30,15) text("Pitch") channel("mapT") $MIDI
button bounds(160,38,9,15) text("") channel("mapTX") $MIDIX
rslider bounds(120,55,60,45) channel("T") range(-12,12,0,1,.01) $RSLIDER
button bounds(190,38,30,15) text("Amp") channel("mapamp") $MIDI
button bounds(220,38,9,15) text("") channel("mapampX") $MIDIX
rslider bounds(180,55,60,45) channel("amp") range(0,2,1,1,.01) $RSLIDER
button bounds(10,105,30,15) text("Port") channel("mappvport") $MIDI
button bounds(40,105,9,15) text("") channel("mappvportX") $MIDIX
rslider bounds(0,120,60,40) channel("pvport") range(0,2,0,.5,.001) $RSLIDER
button bounds(70,105,30,15) text("Start") channel("mapstart") $MIDI
button bounds(100,105,9,15) text("") channel("mapstartX") $MIDIX
rslider bounds(60,120,60,40) channel("start") range(0,10,0,1,.001) $RSLIDER
button bounds(130,105,30,15) text("End") channel("mapend") $MIDI
button bounds(160,105,9,15) text("") channel("mapendX") $MIDIX
rslider bounds(120,120,60,40) channel("end") range(0,10,2,1,.001) $RSLIDER
button bounds(190,105,30,15) text("Dur") channel("mapdur") $MIDI
button bounds(220,105,9,15) text("") channel("mapdurX") $MIDIX
rslider bounds(180,120,60,40) channel("dur") range(0,100,0,.5,.001) $RSLIDER

label bounds(10,163,80,10) text("Randomize Time") $FONT
label bounds(145,163,80,10) text("Randomize Pitch") $FONT
label bounds(98,163,40,10) text("Rate") $FONT
label bounds(98,174,40,10) text("Rand") $FONT
button bounds(10,178,30,15) text("Rate") channel("mappvtimer") $MIDI
button bounds(40,178,9,15) text("") channel("mappvtimerX") $MIDIX
rslider bounds(0,195,60,45) channel("pvtimer") range(0,100,0,.5,.01) $RSLIDER
button bounds(55,178,30,15) text("Depth") channel("mappvtimed") $MIDI
button bounds(85,178,9,15) text("") channel("mappvtimedX") $MIDIX
rslider bounds(45,195,60,45) channel("pvtimed") range(0,1,0,1,.001) $RSLIDER
button bounds(145,178,30,15) text("Rate") channel("mappvTr") $MIDI
button bounds(175,178,9,15) text("") channel("mappvTrX") $MIDIX
rslider bounds(135,195,60,45) channel("pvTr") range(0,100,0,.5,.01) $RSLIDER
button bounds(190,178,30,15) text("Depth") channel("mappvTd") $MIDI
button bounds(220,178,9,15) text("") channel("mappvTdX") $MIDIX
rslider bounds(180,195,60,45) channel("pvTd") range(0,12,0,1,.001) $RSLIDER
button bounds(100,187,30,15) text("Rand") channel("mappvrr") $MIDI
button bounds(130,187,9,15) text("") channel("mappvrrX") $MIDIX
rslider bounds(90,200,60,40) channel("pvrr") range(0,.95,0,.5,.01) $RSLIDER
}

image bounds(250,5,245,250) plant("lp") $PLANT
{
filebutton bounds(70,5,165,25) channel("Lload") text("Load .lp File") $BUTTONS
button bounds(5,5,50,25) channel("Lplay") text("Play") $BUTTONS
button bounds(70,38,30,15) text("Time") channel("mapLpointer") $MIDI
button bounds(100,38,9,15) text("") channel("mapLpointerX") $MIDIX
rslider bounds(60,55,60,45) channel("Lpointer") range(0,1,0,1,.0001) $RSLIDER
button bounds(130,38,30,15) text("Pitch") channel("mapLT") $MIDI
button bounds(160,38,9,15) text("") channel("mapLTX") $MIDIX
rslider bounds(120,55,60,45) channel("LT") range(-12,12,0,1,.01) $RSLIDER
button bounds(190,38,30,15) text("Amp") channel("mapLamp") $MIDI
button bounds(220,38,9,15) text("") channel("mapLampX") $MIDIX
rslider bounds(180,55,60,45) channel("Lamp") range(0,2,1,1,.01) $RSLIDER
button bounds(70,105,30,15) text("Start") channel("mapLstart") $MIDI
button bounds(100,105,9,15) text("") channel("mapLstartX") $MIDIX
rslider bounds(60,120,60,40) channel("Lstart") range(0,10,0,1,.001) $RSLIDER
button bounds(130,105,30,15) text("End") channel("mapLend") $MIDI
button bounds(160,105,9,15) text("") channel("mapLendX") $MIDIX
rslider bounds(120,120,60,40) channel("Lend") range(0,10,2,1,.001) $RSLIDER
button bounds(190,105,30,15) text("Dur") channel("mapLdur") $MIDI
button bounds(220,105,9,15) text("") channel("mapLdurX") $MIDIX
rslider bounds(180,120,60,40) channel("Ldur") range(0,100,0,.5,.001) $RSLIDER

label bounds(5,48,50,10) text("Noise Amp") $FONT
rslider bounds(0,60,60,40) channel("Lnz") range(0,1,.1,.5,.01) $RSLIDER
button bounds(10,105,30,15) text("Port") channel("mapLport") $MIDI
button bounds(40,105,9,15) text("") channel("mapLportX") $MIDIX
rslider bounds(0,120,60,40) channel("Lport") range(0,2,0,.5,.001) $RSLIDER
label bounds(10,163,80,10) text("Randomize Time") $FONT
label bounds(145,163,80,10) text("Randomize Pitch") $FONT
label bounds(98,163,40,10) text("Rate") $FONT
label bounds(98,174,40,10) text("Rand") $FONT
button bounds(10,178,30,15) text("Rate") channel("mapLtimer") $MIDI
button bounds(40,178,9,15) text("") channel("mapLtimerX") $MIDIX
rslider bounds(0,195,60,45) channel("Ltimer") range(0,100,0,.5,.01) $RSLIDER
button bounds(55,178,30,15) text("Depth") channel("mapLtimed") $MIDI
button bounds(85,178,9,15) text("") channel("mapLtimedX") $MIDIX
rslider bounds(45,195,60,45) channel("Ltimed") range(0,1,0,1,.001) $RSLIDER
button bounds(145,178,30,15) text("Rate") channel("mapLTr") $MIDI
button bounds(175,178,9,15) text("") channel("mapLTrX") $MIDIX
rslider bounds(135,195,60,45) channel("LTr") range(0,100,0,.5,.01) $RSLIDER
button bounds(190,178,30,15) text("Depth") channel("mapLTd") $MIDI
button bounds(220,178,9,15) text("") channel("mapLTdX") $MIDIX
rslider bounds(180,195,60,45) channel("LTd") range(0,12,0,1,.001) $RSLIDER
button bounds(100,187,30,15) text("Rand") channel("mapLrr") $MIDI
button bounds(130,187,9,15) text("") channel("mapLrrX") $MIDIX
rslider bounds(90,200,60,40) channel("Lrr") range(0,.95,0,.5,.01) $RSLIDER
}

image bounds(495,5,250,175) plant("LPsource") $PLANT
{
label bounds(5,5,35,13) text("Scale") $FONT
combobox bounds(5,25,85,13) channel("setscale") items("equal temp","1/4 tone","1/3 tone","stretch","compress") $FONT ;ET=12, 1/4 tone=24, 1/3 tone=18, stretched=12.25, compressed=11.75
label bounds(10,40,40,10) text("Notes") $FONT ;12/notes per octave = "sc"
label bounds(10,50,40,10) text("per") $FONT 
label bounds(10,60,40,10) text("Octave") $FONT 
;nslider bounds(5,72,35,13) channel("sc") range(1,48,12,1,.01) $FONT
rslider bounds(0,72,60,40) channel("sc") range(1,48,12,1,.01) $RSLIDER
label bounds(10,117,40,10) text("Scale") $FONT
label bounds(10,127,40,10) text("Start") $FONT
nslider bounds(12,139,35,13) channel("MidiRef") range(0,127,60,1,1) $FONT

;label bounds(5,5,125,13) text("LP Pitch Data From") $FONT
combobox bounds(155,5,90,15) channel("Lkey") text("analysis file","keyboard")
label bounds(95,5,60,13) text("Pitch") $FONT
label bounds(95,20,60,13) text("Source") $FONT
combobox bounds(155,25,90,15) channel("Lsource") text("Pulse","Saw","Square","Triangle","FM","AM","White Noise","Pink Noise")
button bounds(50,44,30,15) text("PW") channel("mappw") identchannel("pwidM") visible(0) $MIDI
button bounds(80,44,9,15) text("") channel("mappwX") identchannel("pwidX") visible(0) $MIDIX
rslider bounds(40,60,60,45) channel("pw") range(.05,.95,.5,1,.01) identchannel("pwid") visible(0) $RSLIDER
button bounds(100,44,30,15) text("Rate") channel("mappwr") identchannel("pwridM") visible(0) $MIDI
button bounds(130,44,9,15) text("") channel("mappwrX") identchannel("pwridX") visible(0) $MIDIX
rslider bounds(90,60,60,45) channel("pwr") range(0,50,0,.5,.01) identchannel("pwrid") visible(0) $RSLIDER 
button bounds(150,44,30,15) text("Depth") channel("mappwd") identchannel("pwdidM") visible(0) $MIDI
button bounds(180,44,9,15) text("") channel("mappwdX") identchannel("pwdidX") visible(0) $MIDIX
rslider bounds(140,60,60,45) channel("pwd") range(0,.75,0,1,.01) identchannel("pwdid") visible(0) $RSLIDER
button bounds(200,44,30,15) text("Rand") channel("mappwrr") identchannel("pwrridM") visible(0) $MIDI
button bounds(230,44,9,15) text("") channel("mappwrrX") identchannel("pwrridX") visible(0) $MIDIX
rslider bounds(190,60,60,45) channel("pwrr") range(0,.95,0,1,.01) identchannel("pwrrid") visible(0) $RSLIDER ;rate random
button bounds(50,44,30,15) text("Ratio") channel("mapmod") identchannel("modidM") visible(0) $MIDI
button bounds(80,44,9,15) text("") channel("mapmodX") identchannel("modidX") visible(0) $MIDIX
rslider bounds(40,60,60,45) channel("mod") range(.05,10,1,1,.001) identchannel("modid") visible(0) $RSLIDER
button bounds(100,44,30,15) text("Rate") channel("mapmodr") identchannel("modridM") visible(0) $MIDI
button bounds(130,44,9,15) text("") channel("mapmodrX") identchannel("modridX") visible(0) $MIDIX
rslider bounds(90,60,60,45) channel("modr") range(0,50,0,.5,.01) identchannel("modrid") visible(0) $RSLIDER 
button bounds(150,44,30,15) text("Depth") channel("mapmodd") identchannel("moddidM") visible(0) $MIDI
button bounds(180,44,9,15) text("") channel("mapmoddX") identchannel("moddidX") visible(0) $MIDIX
rslider bounds(140,60,60,45) channel("modd") range(0,.95,0,1,.001) identchannel("moddid") visible(0) $RSLIDER
button bounds(200,44,30,15) text("Rand") channel("mapmodrr") identchannel("modrridM") visible(0) $MIDI
button bounds(230,44,9,15) text("") channel("mapmodrrX") identchannel("modrridX") visible(0) $MIDIX
rslider bounds(190,60,60,45) channel("modrr") range(0,.95,0,1,.01) identchannel("modrrid") visible(0) $RSLIDER ;rate random
button bounds(50,108,30,15) text("Index") channel("mapind") identchannel("indidM") visible(0) $MIDI
button bounds(80,108,9,15) text("") channel("mapindX") identchannel("indidX") visible(0) $MIDIX
rslider bounds(40,125,60,45) channel("ind") range(0,1,0,1,.001) identchannel("indid") visible(0) $RSLIDER
button bounds(100,108,30,15) text("Rate") channel("mapindr") identchannel("indridM") visible(0) $MIDI
button bounds(130,108,9,15) text("") channel("mapindrX") identchannel("indridX") visible(0) $MIDIX
rslider bounds(90,125,60,45) channel("indr") range(0,50,0,.5,.01) identchannel("indrid") visible(0) $RSLIDER 
button bounds(150,108,30,15) text("Depth") channel("mapindd") identchannel("inddidM") visible(0) $MIDI
button bounds(180,108,9,15) text("") channel("mapinddX") identchannel("inddidX") visible(0) $MIDIX
rslider bounds(140,125,60,45) channel("indd") range(0,.95,0,1,.01) identchannel("inddid") visible(0) $RSLIDER
button bounds(200,108,30,15) text("Rand") channel("mapindrr") identchannel("indrridM") visible(0) $MIDI
button bounds(230,108,9,15) text("") channel("mapindrrX") identchannel("indrridX") visible(0) $MIDIX
rslider bounds(190,125,60,45) channel("indrr") range(0,.95,0,1,.01) identchannel("indrrid") visible(0) $RSLIDER ;rate random
}

image bounds(745,5,245,105) plant("adsyn") $PLANT
{
filebutton bounds(70,5,165,25) channel("Hload") text("Load .het File") $BUTTONS
button bounds(5,5,50,25) channel("Hplay") text("Play") $BUTTONS
button bounds(70,38,30,15) text("Speed") channel("mapHspeed") $MIDI
button bounds(100,38,9,15) text("") channel("mapHspeedX") $MIDIX
rslider bounds(60,55,60,45) channel("Hspeed") range(.01,3,1,1,.01) $RSLIDER
button bounds(130,38,30,15) text("Pitch") channel("mapHT") $MIDI
button bounds(160,38,9,15) text("") channel("mapHTX") $MIDIX
rslider bounds(120,55,60,45) channel("HT") range(-12,12,0,1,.01) $RSLIDER
button bounds(190,38,30,15) text("Amp") channel("mapHamp") $MIDI
button bounds(220,38,9,15) text("") channel("mapHampX") $MIDIX
rslider bounds(180,55,60,45) channel("Hamp") range(0,2,1,1,.01) $RSLIDER
}

image bounds(745,110,245,70) plant("Record") $PLANT
{
label bounds(5, 5, 50, 13) text("Presets") $FONT
combobox bounds(58, 5, 140, 15), channel("combobox"), populate("*.snaps")
filebutton bounds(200, 5, 40, 15), channel("preset"), text("Save"), mode("snapshot")
button bounds(5,30,70,30), channel("record") text("Record","Stop") colour("red") $FONT
combobox bounds(155,30,70,15) channel("recch") value(2) text("mono","stereo") $FONT
combobox bounds(155,47,70,15) channel("bit") value(1) text("16-bit","24-bit","32-bit") $FONT
button bounds(80,30,70,30), channel("play") text("Play") colour("green") $FONT
}

image bounds(5,255,185,300) plant("FFT") $PLANT
{
button bounds(13,5,40,18) channel("shifton") text("Shift") value((0) $BUTTONS
combobox   bounds(10,25,50,12), channel("shiftsize"), items("32768", "16384", "8192", "4096", "2048", "1024", "512", "256", "128", "64", "32", "16", "8", "4"), value(6) $FONT
button bounds(15,40,30,15) text("Shift") channel("mapshift") $MIDI
button bounds(45,40,9,15) text("") channel("mapshiftX") $MIDIX
rslider bounds(0,55,70,45) channel("shift") range(-1,1,0,1,.0001) $RSLIDER
button bounds(15,105,30,15) text("Lowest") channel("maplowest") $MIDI
button bounds(45,105,9,15) text("") channel("maplowestX") $MIDIX
rslider bounds(0,120,70,45) channel("lowest") range(0,1,0,.5,.0001) $RSLIDER
button bounds(15,235,30,15) text("Mix") channel("mapshiftmix") $MIDI
button bounds(45,235,9,15) text("") channel("mapshiftmixX") $MIDIX
rslider bounds(0,250,70,45) channel("shiftmix") range(0,1,.5,1,.01) $RSLIDER

button bounds(73,5,40,18) channel("warpon") text("Warp") value(0) $BUTTONS
combobox   bounds(70,25,50,13), channel("warpsize"), items("32768", "16384", "8192", "4096", "2048", "1024", "512", "256", "128", "64", "32", "16", "8", "4"), value(6) $FONT
button bounds(75,40,30,15) text("Scale") channel("mapenvscale") $MIDI
button bounds(105,40,9,15) text("") channel("mapenvscaleX") $MIDIX
rslider bounds(60,55,70,45) channel("envscale") range(.1,10,1,.5,.0001) $RSLIDER
button bounds(75,105,30,15) text("Shift") channel("mapenvshift") $MIDI
button bounds(105,105,9,15) text("") channel("mapenvshiftX") $MIDIX
rslider bounds(60,120,70,45) channel("envshift") range(-1,1,0,1,.0001) $RSLIDER
button bounds(75,170,30,15) text("Lowest") channel("mapenvlowest") $MIDI
button bounds(105,170,9,15) text("") channel("mapenvlowestX") $MIDIX
rslider bounds(60,185,70,45) channel("envlowest") range(0,1,0,.5,.0001) $RSLIDER
button bounds(75,235,30,15) text("Mix") channel("mapwarpmix") $MIDI
button bounds(105,235,9,15) text("") channel("mapwarpmixX") $MIDIX
rslider bounds(60,250,70,45) channel("warpmix") range(0,1,.5,1,.01) $RSLIDER

button bounds(133,5,40,18) channel("smoothon") text("Smooth") value(0) $BUTTONS
combobox   bounds(130,25,50,13), channel("smoothsize"), items("32768", "16384", "8192", "4096", "2048", "1024", "512", "256", "128", "64", "32", "16", "8", "4"), value(6) $FONT
button bounds(135,40,30,15) text("Amp") channel("mapampsmooth") $MIDI
button bounds(165,40,9,15) text("") channel("mapampsmoothX") $MIDIX
rslider bounds(120,55,70,45) channel("ampsmooth") range(0,1,0,.5,.0001) $RSLIDER
button bounds(135,105,30,15) text("Freq") channel("mapfreqsmooth") $MIDI
button bounds(165,105,9,15) text("") channel("mapfreqsmoothX") $MIDIX
rslider bounds(120,120,70,45) channel("freqsmooth") range(0,1,0,.5,.0001) $RSLIDER
button bounds(135,235,30,15) text("Mix") channel("mapsmoothmix") $MIDI
button bounds(165,235,9,15) text("") channel("mapsmoothmixX") $MIDIX
rslider bounds(120,250,70,45) channel("smoothmix") range(0,1,.5,1,.01) $RSLIDER
}

image bounds(190,255,375,300) plant("Arpeggiator") $PLANT
{
button bounds(10,5,60,18) channel("arpon") text("Arpeggios") value(0) $BUTTONS
combobox   bounds(15,25,50,13), channel("arpsize"), items("32768", "16384", "8192", "4096", "2048", "1024", "512", "256", "128", "64", "32", "16", "8", "4"), value(6) $FONT
button bounds(20,40,30,15) text("Bin") channel("maparpbin1") $MIDI
button bounds(50,40,9,15) text("") channel("maparpbin1X") $MIDIX
rslider bounds(0,55,80,45) channel("arpbin1") range(0,1,.1,.5,.0001) $RSLIDER
button bounds(15,105,40,15) text("B Damp") channel("maparpdepth1") $MIDI
button bounds(55,105,9,15) text("") channel("maparpdepth1X") $MIDIX
rslider bounds(0,120,80,45) channel("arpdepth1") range(0,100,.75,.5,.01) $RSLIDER
button bounds(15,170,40,15) text("B Gain") channel("maparpgain1") $MIDI
button bounds(55,170,9,15) text("") channel("maparpgain1X") $MIDIX
rslider bounds(0,185,80,45) channel("arpgain1") range(0,100,2,.5,.01) $RSLIDER
button bounds(20,235,30,15) text("Amp") channel("maparpamp1") $MIDI
button bounds(50,235,9,15) text("") channel("maparpamp1X") $MIDIX
rslider bounds(0,250,80,45) channel("arpamp1") range(0,1,.5,1,.01) $RSLIDER
combobox bounds(75,20,50,13) channel("arpshape1") text("sine", "triangle", "square", "rampup", "rampdown", "pulse", "S&H", "rand")
button bounds(75,40,40,15) text("V Width") channel("maparpwidth1") $MIDI
button bounds(115,40,9,15) text("") channel("maparpwidth1X") $MIDIX
rslider bounds(60,55,80,45) channel("arpwidth1") range(0,1,.1,.5,.0001) $RSLIDER
button bounds(75,105,40,15) text("V Speed") channel("maparpspeed1") $MIDI
button bounds(115,105,9,15) text("") channel("maparpspeed1X") $MIDIX
rslider bounds(60,120,80,45) channel("arpspeed1") range(0,100,0,.5,.01) $RSLIDER
button bounds(75,170,40,15) text("V Rand") channel("maparprand1") $MIDI
button bounds(115,170,9,15) text("") channel("maparprand1X") $MIDIX
rslider bounds(60,185,80,45) channel("arprand1") range(0,1,0,1,.01) $RSLIDER

button bounds(140,40,30,15) text("Bin") channel("maparpbin2") $MIDI
button bounds(170,40,9,15) text("") channel("maparpbin2X") $MIDIX
rslider bounds(120,55,80,45) channel("arpbin2") range(0,1,.2,.5,.0001) $RSLIDER
button bounds(135,105,40,15) text("B Damp") channel("maparpdepth2") $MIDI
button bounds(175,105,9,15) text("") channel("maparpdepth2X") $MIDIX
rslider bounds(120,120,80,45) channel("arpdepth2") range(0,100,.75,.5,.01) $RSLIDER
button bounds(135,170,40,15) text("B Gain") channel("maparpgain2") $MIDI
button bounds(175,170,9,15) text("") channel("maparpgain2X") $MIDIX
rslider bounds(120,185,80,45) channel("arpgain2") range(0,100,2,.5,.01) $RSLIDER
button bounds(140,235,30,15) text("Amp") channel("maparpamp2") $MIDI
button bounds(170,235,9,15) text("") channel("maparpamp2X") $MIDIX
rslider bounds(120,250,80,45) channel("arpamp2") range(0,1,.5,1,.01) $RSLIDER
combobox bounds(195,20,50,13) channel("arpshape2") text("sine", "triangle", "square", "rampup", "rampdown", "pulse", "S&H", "rand")
button bounds(195,40,40,15) text("V Width") channel("maparpwidth2") $MIDI
button bounds(235,40,9,15) text("") channel("maparpwidth2X") $MIDIX
rslider bounds(180,55,80,45) channel("arpwidth2") range(0,1,.1,.5,.0001) $RSLIDER
button bounds(195,105,40,15) text("V Speed") channel("maparpspeed2") $MIDI
button bounds(235,105,9,15) text("") channel("maparpspeed2X") $MIDIX
rslider bounds(180,120,80,45) channel("arpspeed2") range(0,100,0,.5,.01) $RSLIDER
button bounds(195,170,40,15) text("V Rand") channel("maparprand2") $MIDI
button bounds(235,170,9,15) text("") channel("maparprand2X") $MIDIX
rslider bounds(180,185,80,45) channel("arprand2") range(0,1,0,1,.01) $RSLIDER

button bounds(260,40,30,15) text("Bin") channel("maparpbin3") $MIDI
button bounds(290,40,9,15) text("") channel("maparpbin3X") $MIDIX
rslider bounds(240,55,80,45) channel("arpbin3") range(0,1,.3,.5,.0001) $RSLIDER
button bounds(255,105,40,15) text("B Damp") channel("maparpdepth3") $MIDI
button bounds(295,105,9,15) text("") channel("maparpdepth3X") $MIDIX
rslider bounds(240,120,80,45) channel("arpdepth3") range(0,100,.75,.5,.01) $RSLIDER
button bounds(255,170,40,15) text("B Gain") channel("maparpgain3") $MIDI
button bounds(295,170,9,15) text("") channel("maparpgain3X") $MIDIX
rslider bounds(240,185,80,45) channel("arpgain3") range(0,100,2,.5,.01) $RSLIDER
button bounds(260,235,30,15) text("Amp") channel("maparpamp3") $MIDI
button bounds(290,235,9,15) text("") channel("maparpamp3X") $MIDIX
rslider bounds(240,250,80,45) channel("arpamp3") range(0,1,.5,1,.01) $RSLIDER
combobox bounds(315,20,50,13) channel("arpshape3") text("sine", "triangle", "square", "rampup", "rampdown", "pulse", "S&H", "rand")
button bounds(315,40,40,15) text("V Width") channel("maparpwidth3") $MIDI
button bounds(355,40,9,15) text("") channel("maparpwidth3X") $MIDIX
rslider bounds(300,55,80,45) channel("arpwidth3") range(0,1,.1,.5,.0001) $RSLIDER
button bounds(315,105,40,15) text("V Speed") channel("maparpspeed3") $MIDI
button bounds(355,105,9,15) text("") channel("maparpspeed3X") $MIDIX
rslider bounds(300,120,80,45) channel("arpspeed3") range(0,100,0,.5,.01) $RSLIDER
button bounds(315,170,40,15) text("V Rand") channel("maparprand3") $MIDI
button bounds(355,170,9,15) text("") channel("maparprand3X") $MIDIX
rslider bounds(300,185,80,45) channel("arprand3") range(0,1,0,1,.01) $RSLIDER

button bounds(320,235,30,15) text("Mix") channel("maparpmix") $MIDI
button bounds(350,235,9,15) text("") channel("maparpmixX") $MIDIX
rslider bounds(305,250,70,45) channel("arpmix") range(0,1,.5,1,.01) $RSLIDER
}

image bounds(565,180,425,175) plant("Transposers") $PLANT
{
button bounds(5,5,75,18) channel("ton") text("Transposer", "Transposer") $BUTTONS
combobox   bounds(100,5,50,13), channel("Tsize"), items("32768", "16384", "8192", "4096", "2048", "1024", "512"), value(6) $FONT

combobox bounds(200,5,80,13) channel("Tpresets") text("Fat","Fatter","Warble","5ths","4ths","M3rds","Mi3rds","Cluster 1","Cluster 2","Whole Tones","Stacked 5ths","Stacked 4ths","Stacked M3rds","Stacked Mi3rds","8ves","Big 5ths","Major","Minor","V7","M7","M9","Mi7","Sus","V7sus","V7+9","V9","V7+9B")
button bounds(15,44,30,15) text("Port") channel("mapTport") $MIDI
button bounds(45,44,9,15) text("") channel("mapTportX") $MIDIX
rslider bounds(0,60,70,45) channel("Tport") range(0,5,.02,.25,0.01) $RSLIDER
button bounds(15,107,30,15) text("Mix") channel("mapharmmix") $MIDI
button bounds(45,107,9,15) text("") channel("mapharmmixX") $MIDIX
rslider bounds(0,123,70,45) channel("harmmix") range(0, 1, .5, 1, 0.01) $RSLIDER

button bounds(83,27,22,15) channel("harmon1") text("Off", "On") value(1) $BUTTONS
button bounds(75,44,30,15) text("Coarse") channel("mapharmon1C") $MIDI
button bounds(105,44,9,15) text("") channel("mapharmon1CX") $MIDIX
rslider bounds(60,60,70,45) channel("harmon1C") range(-24, 24, 0, 1, 1) $RSLIDER
button bounds(75,107,30,15) text("Fine") channel("mapharmon1F") $MIDI
button bounds(105,107,9,15) text("") channel("mapharmon1FX") $MIDIX
rslider bounds(60,123,70,45) channel("harmon1F") range(-1, 1, .14, 1, 0.01) $RSLIDER
button bounds(143,27,22,15) channel("harmon2") text("Off", "On") value(1) $BUTTONS
button bounds(135,44,30,15) text("Coarse") channel("mapharmon2C") $MIDI
button bounds(165,44,9,15) text("") channel("mapharmon2CX") $MIDIX
rslider bounds(120,60,70,45) channel("harmon2C") range(-24, 24, 0, 1, 1) $RSLIDER
button bounds(135,107,30,15) text("Fine") channel("mapharmon2F") $MIDI
button bounds(165,107,9,15) text("") channel("mapharmon2FX") $MIDIX
rslider bounds(120,123,70,45) channel("harmon2F") range(-1, 1, 0-.16, 1, 0.01) $RSLIDER
button bounds(203,27,22,15) channel("harmon3") text("Off", "On") value(1) $BUTTONS
button bounds(195,44,30,15) text("Coarse") channel("mapharmon3C") $MIDI
button bounds(225,44,9,15) text("") channel("mapharmon3CX") $MIDIX
rslider bounds(180,60,70,45) channel("harmon3C") range(-24, 24, 0, 1, 1) $RSLIDER
button bounds(195,107,30,15) text("Fine") channel("mapharmon3F") $MIDI
button bounds(225,107,9,15) text("") channel("mapharmon3FX") $MIDIX
rslider bounds(180,123,70,45) channel("harmon3F") range(-1, 1, .09, 1, 0.01) $RSLIDER
button bounds(263,27,22,15) channel("harmon4") text("Off", "On") value(1) $BUTTONS
button bounds(255,44,30,15) text("Coarse") channel("mapharmon4C") $MIDI
button bounds(285,44,9,15) text("") channel("mapharmon4CX") $MIDIX
rslider bounds(240,60,70,45) channel("harmon4C") range(-24, 24, 0, 1, 1) $RSLIDER
button bounds(255,107,30,15) text("Fine") channel("mapharmon4F") $MIDI
button bounds(285,107,9,15) text("") channel("mapharmon4FX") $MIDIX
rslider bounds(240,123,70,45) channel("harmon4F") range(-1, 1, 0-.12, 1, 0.01) $RSLIDER
button bounds(323,27,22,15) channel("harmon5") text("Off", "On") value(1) $BUTTONS
button bounds(315,44,30,15) text("Coarse") channel("mapharmon5C") $MIDI
button bounds(345,44,9,15) text("") channel("mapharmon5CX") $MIDIX
rslider bounds(300,60,70,45) channel("harmon5C") range(-24, 24, 0, 1, 1) $RSLIDER
button bounds(315,107,30,15) text("Fine") channel("mapharmon5F") $MIDI
button bounds(345,107,9,15) text("") channel("mapharmon5FX") $MIDIX
rslider bounds(300,123,70,45) channel("harmon5F") range(-1, 1, 0.11, 1, 0.01) $RSLIDER
button bounds(383,27,22,15) channel("harmon6") text("Off", "On") value(1) $BUTTONS
button bounds(375,44,30,15) text("Coarse") channel("mapharmon6C") $MIDI
button bounds(405,44,9,15) text("") channel("mapharmon6CX") $MIDIX
rslider bounds(360,60,70,45) channel("harmon6C") range(-24, 24, 0, 1, 1) $RSLIDER
button bounds(375,107,30,15) text("Fine") channel("mapharmon6F") $MIDI
button bounds(405,107,9,15) text("") channel("mapharmon6FX") $MIDIX
rslider bounds(360,123,70,45) channel("harmon6F") range(-1, 1, -.05, 1, 0.01) $RSLIDER
}

;Distortion
image bounds(850,355,140,70) plant("Distort") $PLANT
{
button bounds(48,5,45,18) channel("diston") text("Distort", "Distort") value(0) $BUTTONS
button bounds(8,25,30,15) text("Dist") channel("mapdist") $MIDI
button bounds(38,25,9,15) text("") channel("mapdistX") $MIDIX
rslider bounds(13,40,25,25) channel("dist") range(0, 1, 0, 1, 0.01) $BASIC 
button bounds(50,25,30,15) text("Shape") channel("mapdist2") $MIDI
button bounds(80,25,9,15) text("") channel("mapdist2X") $MIDIX
rslider bounds(55,40,25,25) channel("dist2") range(0, .999, 0, 1, 0.001) $BASIC 
button bounds(92,25,30,15) text("Fold") channel("mapdist3") $MIDI
button bounds(123,25,9,15) text("") channel("mapdist3X") $MIDIX
rslider bounds(97,40,25,25) channel("dist3") range(1, 25, 1, .5, 0.001) $BASIC 
}

;LP Filter
image bounds(565,355,145,100) plant("LP") $PLANT
{
button bounds(48,2,50,17) channel("LPon") text("Lowpass", "Lowpass") value(0) $BUTTONS
combobox bounds(90,25,45,12) channel("LPsel") text("-6 dB","-12 dB","-18 dB","-24 dB")
label bounds(43,60,55,8) text("rate  depth") $FONT
label bounds(102,49,25,8) text("rand") $FONT
button bounds(10,25,27,13) text("Cutoff") channel("mapLPcps") $MIDI
button bounds(37,25,9,13) text("") channel("mapLPcpsX") $MIDIX
rslider bounds(15,36,25,25) channel("LPcps") range(2, 14, 11, 1, .001) $BASIC ;pitch expressed in oct
button bounds(10,60,27,13) text("Res") channel("mapLPres") $MIDI
button bounds(37,60,9,13) text("") channel("mapLPresX") $MIDIX
rslider bounds(15,71,25,25) channel("LPres") range(0.01, .99, 0.1, 1, 0.01) $BASIC
rslider bounds(49,40,20,20) channel("LPcfr") range(0,75,0,.5,.01) $BASIC
rslider bounds(70,40,20,20) channel("LPcfd") range(0,2.5,0,.5,.01) $BASIC
rslider bounds(105,58,20,20) channel("LPrand") range(0,.95,0,1,.01) $BASIC
rslider bounds(49,73,20,20) channel("LPresr") range(0,75,0,.5,.01) $BASIC
rslider bounds(70,73,20,20) channel("LPresd") range(0,2.5,0,.5,.01) $BASIC
}

;Parallel Filters (selectable)
image bounds(850,425,140,220) plant("parallel") $PLANT
{
button bounds(5,2,45,17) channel("paron") text("Filters") value(0) $BUTTONS
combobox bounds(53,3,78,15) channel("vpresets") text("Voice Formants","Soprano ah","Soprano eh","Soprano ih","Soprano oh","Soprano uh","Alto ah","Alto eh","Alto ih","Alto oh","Alto uh","Tenor ah","Tenor eh","Tenor ih","Tenor oh","Tenor uh","Bass ah","Bass eh","Bass ih","Bass oh","Bass uh", )
label bounds(12,187,25,8) text("port") $FONT
rslider bounds(15,195,20,20) channel("fport") range(0,5,.1,.25,0.01) $BASIC 
label bounds(5,20,35,10) text("Select") $FONT
label bounds(41,20,35,10) text("Cutoff") $FONT
label bounds(4,60,55,8) text("rate depth rand") $FONT
label bounds(70,20,35,10) text("Res") $FONT
label bounds(101,20,35,10) text("Amp") $FONT
combobox bounds(5,35,36,12) channel("parsel1") text("LP","BP","HP","off") identchannel("ps1") value(1) 
combobox bounds(5,80,36,12) channel("parsel2") text("LP","BP","HP","off") value(2)
combobox bounds(5,125,36,12) channel("parsel3") text("LP","BP","HP","off") value(2)
combobox bounds(5,170,36,12) channel("parsel4") text("LP","BP","HP","off") value(3)
rslider bounds(46,29,25,25) channel("parF1") range(2,14,8,1,0.001) $BASIC  ;expressing pitch in oct and resonance needs to be between .5-25
rslider bounds(46,74,25,25) channel("parF2") range(2,14,9,1,0.001) $BASIC 
rslider bounds(46,119,25,25) channel("parF3") range(2,14,10,1,0.001) $BASIC 
rslider bounds(46,164,25,25) channel("parF4") range(2,14,11,1,0.001) $BASIC 
rslider bounds(60,54,20,20) channel("parcfr1") range(0,75,0,.5,.01) $BASIC
rslider bounds(60,99,20,20) channel("parcfr2") range(0,75,0,.5,.01) $BASIC
rslider bounds(60,144,20,20) channel("parcfr3") range(0,75,0,.5,.01) $BASIC
rslider bounds(60,189,20,20) channel("parcfr4") range(0,75,0,.5,.01) $BASIC
rslider bounds(80,54,20,20) channel("parcfd1") range(0,2.5,0,.5,.001) $BASIC ;depth calculated in oct as well
rslider bounds(80,99,20,20) channel("parcfd2") range(0,2.5,0,.5,.001) $BASIC
rslider bounds(80,144,20,20) channel("parcfd3") range(0,2.5,0,.5,.001) $BASIC
rslider bounds(80,189,20,20) channel("parcfd4") range(0,2.5,0,.5,.001) $BASIC
rslider bounds(100,54,20,20) channel("parcfrnd1") range(0,.95,0,1,.01) $BASIC
rslider bounds(100,99,20,20) channel("parcfrnd2") range(0,.95,0,1,.01) $BASIC
rslider bounds(100,144,20,20) channel("parcfrnd3") range(0,.95,0,1,.01) $BASIC
rslider bounds(100,189,20,20) channel("parcfrnd4") range(0,.95,0,1,.01) $BASIC
rslider bounds(76,29,25,25) channel("parres1") range(.5,25,1,1,0.01) $BASIC
rslider bounds(76,74,25,25) channel("parres2") range(.5,25,1,1,0.01) $BASIC 
rslider bounds(76,119,25,25) channel("parres3") range(.5,25,1,1,0.01) $BASIC 
rslider bounds(76,164,25,25) channel("parres4") range(.5,25,1,1,0.01) $BASIC
rslider bounds(106,29,25,25) channel("paramp1") range(0,1.5,1,1,0.001) $BASIC 
rslider bounds(106,74,25,25) channel("paramp2") range(0,1.5,1,1,0.001) $BASIC 
rslider bounds(106,119,25,25) channel("paramp3") range(0,1.5,1,1,0.001) $BASIC
rslider bounds(106,164,25,25) channel("paramp4") range(0,1.5,1,1,0.001) $BASIC
}

;phaser
image bounds(565,455,82,100) plant("Phaser") $PLANT
{
button bounds(19,2,45,17) channel("phson") text("Phaser", "Phaser") $BUTTONS
button bounds(13,28,27,15) text("Speed") channel("mapphscps") $MIDI
button bounds(40,28,9,15) text("") channel("mapphscpsX") $MIDIX
rslider bounds(50,23,25,25) channel("phscps") range(0.01, 100, .4, 0.25, 0.01) $BASIC
button bounds(13,51,27,15) text("FB") channel("mapphsFB") $MIDI
button bounds(40,51,9,15) text("") channel("mapphsFBX") $MIDIX
rslider bounds(50,46,25,25) channel("phsFB") range(0, 1, 0.5, 1, 0.01) $BASIC
button bounds(13,74,27,15) text("Q") channel("mapphsQ") $MIDI
button bounds(40,74,9,15) text("") channel("mapphsQX") $MIDIX
rslider bounds(50,70,25,25) channel("phsQ") range(0.01, 100, 1, .25, 0.01) $BASIC
}

;flanger
image bounds(647,455,58,100) plant("Flanger") $PLANT
{
button bounds(8,2,40,17) channel("flon") text("Flanger", "Flanger") $BUTTONS
button bounds(11,25,27,15) text("Speed") channel("mapflcps") $MIDI
button bounds(38,25,9,15) text("") channel("mapflcpsX") $MIDIX
rslider bounds(16,38,25,25) channel("flcps") range(0.01, 100, .05, 0.25, 0.01) $BASIC
button bounds(11,61,27,15) text("FB") channel("mapflFB") $MIDI
button bounds(38,61,9,15) text("") channel("mapflFBX") $MIDIX
rslider bounds(16,74,25,25) channel("flFB") range(0, .99, 0.5, 1, 0.01) $BASIC
}

;Chorus
image bounds(710,355,140,100) plant("Chorus") $PLANT
{
;label bounds(2, 2, 35, 10) text("Chorus") $FONT
button bounds(45,2,45,17) channel("chon") text("Chorus", "Chorus") $BUTTONS
button bounds(10,24,27,15) text("Mix") channel("mapchmix") $MIDI
button bounds(37,24,9,15) text("") channel("mapchmixX") $MIDIX
button bounds(49,24,27,15) text("Rate") channel("mapchcps") $MIDI
button bounds(76,24,9,15) text("") channel("mapchcpsX") $MIDIX
button bounds(88,24,27,15) text("FB") channel("mapchFB") $MIDI
button bounds(115,24,9,15) text("") channel("mapchFBX") $MIDIX
rslider bounds(14, 37, 25, 25) channel("chmix") range(0, 1, .5, 1, 0.01) $BASIC 
rslider bounds(53, 37, 25, 25) channel("chcps") range(.01, 25, .5, .5, 0.001) $BASIC 
rslider bounds(92, 37, 25, 25) channel("chFB") range(0, .999, .7, 1, 0.001) $BASIC 
button bounds(10,60,27,15) text("Depth") channel("mapchdepth") $MIDI
button bounds(37,60,9,15) text("") channel("mapchdepthX") $MIDIX
button bounds(48,60,27,15) text("Delay") channel("mapchdel") $MIDI
button bounds(76,60,9,15) text("") channel("mapchdelX") $MIDIX
button bounds(88,60,27,15) text("Rand") channel("mapchrand") $MIDI
button bounds(115,60,9,15) text("") channel("mapchrandX") $MIDIX
rslider bounds(14, 73, 25, 25) channel("chdepth") range(.1, 50, 1.5, .5, 0.01) $BASIC 
rslider bounds(53, 73, 25, 25) channel("chdel") range(.1, 50, 15, 1, 0.01) $BASIC 
rslider bounds(92, 73, 25, 25) channel("chrand") range(0, .9, .1, .5, 0.001) $BASIC 
}

;delay
image bounds(705,455,58,100) plant("Delay") $PLANT
{
;label bounds(2,2,30,10) text("Delay") $FONT
button bounds(8,2,40,17) channel("delon") text("Delay", "Delay") $BUTTONS
button bounds(10,24,27,15) text("Time") channel("mapdeltime") $MIDI
button bounds(37,24,9,15) text("") channel("mapdeltimeX") $MIDIX
rslider bounds(15,37,25,25) channel("deltime") range(0.001, 4.99, .08, 0.25, 0.0001) $BASIC
button bounds(10,60,27,15) text("FB") channel("mapdelFB") $MIDI
button bounds(37,60,9,15) text("") channel("mapdelFBX") $MIDIX
rslider bounds(15,73,25,25) channel("delFB") range(0, .99, .35, 1, 0.01) $BASIC
}

;reverbsc
image bounds(763,455,87,100) plant("Reverb") $PLANT
{
;label bounds(2,2,40,10) text("Reverb") $FONT
button bounds(23,2,45,17) channel("revon") text("Reverb", "Reverb") $BUTTONS
button bounds(14,28,30,15) text("Mix") channel("maprevmix") $MIDI
button bounds(44,28,9,15) text("") channel("maprevmixX") $MIDIX
rslider bounds(53,23,25,25) channel("revmix") range(0,1, .35, 1, 0.01) $BASIC
button bounds(14,51,30,15) text("Decay") channel("maprevFB") $MIDI
button bounds(44,51,9,15) text("") channel("maprevFBX") $MIDIX
rslider bounds(53,46,25,25) channel("revFB") range(0.01,0.999, .75, 1.75, 0.001) $BASIC
button bounds(14,74,30,15) text("LP") channel("maprevLP") $MIDI
button bounds(44,74,9,15) text("") channel("maprevLPX") $MIDIX
rslider bounds(53,69,25,25) channel("revLP") range(200, 20000, 12500, .5, 10) $BASIC
}

</Cabbage>
<CsoundSynthesizer>
<CsOptions>
-n -d -+rtmidi=NULL -M0 -m0d --midi-key=4 --midi-velocity-amp=5
</CsOptions>
<CsInstruments>
; Initialize the global variables. 
ksmps = 32
nchnls = 2
0dbfs = 1
massign 0,7 ;only using for Linear Prediction instrument

gkRecordingActiveFlag,gkFileRecorded init 0
gasrcL,gasrcR,gaFFTL,gaFFTR,gaChorL,gaChorR,gaDelL,gaDelR,gaFXL,gaFXR,gafinalL,gafinalR init 0
gaFFTL,gaFFTR init 0
giFFTSizes[]	array	32768, 16384, 8192, 4096, 2048, 1024, 512, 256, 128, 64, 32, 16, 8, 4	; an array is used to store FFT window sizes

instr 1  ;instrument senses the GUI objects
kplay chnget "pvplay"
if changed(kplay) == 1 then ;turns on pvoc player (uses .pvx analysis files)
    if kplay=1 then 
    event "i",5,0,10000
    else
    turnoff2  5,0,.05
    endif
endif
kHplay chnget "Hplay"
if changed(kHplay) == 1 then ;turns on adsyn player (uses .het analysis files)
    if kHplay=1 then 
    event "i",6,0,10000
    else
    turnoff2  6,0,.05
    endif
endif
kLplay chnget "Lplay"
if changed(kLplay) == 1 then ;turns on adsyn player (uses .het analysis files)
    if kLplay=1 then 
    event "i",7,0,10000
    else
    turnoff2  7,0,.05
    endif
endif
gkrecord	chnget	"record"
gkplay		chnget	"play"
kRecStart	trigger	gkrecord,0.5,0
  if kRecStart==1 && gkRecordingActiveFlag==0 then
    event	"i",600,0,-1
    gkRecordingActiveFlag	=	1
  endif
  kPlayStart	trigger	gkplay,0.5,0
  if kPlayStart==1 && gkFileRecorded==1 then
    event	"i",601,ksmps/sr,3600
  endif
gkFFTSize	chnget	"FFTSize"
gkshiftsize chnget "shiftsize"
gkwarpsize chnget "warpsize"
gksmoothsize chnget "smoothsize"
gkarpsize chnget "arpsize"
gkTsize chnget "Tsize"
kss chnget "setscale"
gksc chnget "sc"
if changed(kss)==1 then
 if kss=1 then
 gksc=12
 elseif kss=2 then
 gksc=24
 elseif kss=3 then
 gksc=18
 elseif kss=4 then
 gksc=12.25
 elseif kss=5 then
 gksc=11.75
 endif
 chnset gksc,"sc"
endif
endin

instr 5 ;pvoc file player
kport chnget "pvport"
Sfilepath chnget "load"
idur chnget "dur"
if idur>0 then
kpointer line 0,idur,1
else
kpointer chnget "pointer"
endif
kamp chnget "amp"
kamp portk kamp,.02
kenv madsr .02,.02,1,.02
kstart chnget "start"
kstart portk kstart,.02
kend chnget "end"
kend portk kend,.02

kpvrr chnget "pvrr"
ktimer chnget "pvtimer"
ktimed chnget "pvtimed"
kTr chnget "pvTr"
kTd chnget "pvTd"
ktimerr randi ktimer*kpvrr,ktimer,2
ktimedev randh ktimed,ktimer+ktimerr,2
kpointer=kpointer+ktimedev
  if kpointer<0 then
  kpointer=0
  elseif kpointer>1 then
  kpointer=1
  endif
kpointer portk kpointer,kport
klength=kend-kstart
ktime=(klength*kpointer)+kstart
kTrr randi kTr*kpvrr,kTr,2
kTdev randh kTd,kTr+kTrr,2
kTdev portk kTdev,kport
kT chnget "T"
kT=kT+kTdev
  if kT<-12 then
  kT=-12
  elseif kT>12 then
  kT=12
  endif
kT portk kT,kport

kfmod=semitone(kT)
a1 pvoc ktime,kfmod,Sfilepath ;consider adding parameters for extractmoddd to hard filter out bins, only i-rate though
gasrcL=(a1*kamp)+gasrcL
gasrcR=(a1*kamp)+gasrcR
endin

instr 6 ;adsyn file player
SHfilepath chnget "Hload"
kamp chnget "Hamp"
kamp portk kamp,.02
kenv madsr .02,.02,1,.02
kspeed chnget "Hspeed"
kspeed portk kspeed,.02
kT chnget "HT"
kT portk kT,.02
kfmod=semitone(kT)
a1 adsyn kamp,kfmod,kspeed,SHfilepath ;consider adding parameters for extractmoddd to hard filter out bins, only i-rate though
gasrcL=a1+gasrcL
gasrcR=a1+gasrcR
endin

instr 7 ;lp file player, p4=cps and p5=amp
Sfilepath chnget "Lload"
idur chnget "Ldur"
  if idur>0 then
  kpointer line 0,idur,1
  else
  kpointer chnget "Lpointer"
  endif

kamp chnget "Lamp"
kamp portk kamp,.02
kenv madsr .02,.02,1,.02
kstart chnget "Lstart"
kstart portk kstart,.02
kend chnget "Lend"
kend portk kend,.02

kport chnget "Lport"
kLrr chnget "Lrr"
ktimer chnget "Ltimer"
ktimed chnget "Ltimed"
kTr chnget "LTr"
kTd chnget "LTd"
ktimerr randi ktimer*kLrr,ktimer,2
ktimedev randh ktimed,ktimer+ktimerr,2
kpointer=kpointer+ktimedev
  if kpointer<0 then
  kpointer=0
  elseif kpointer>1 then
  kpointer=1
  endif
kpointer portk kpointer,kport
klength=kend-kstart
ktime=(klength*kpointer)+kstart

kTrr randi kTr*kLrr,kTr,2
kTdev randh kTd,kTr+kTrr,2
kTdev portk kTdev,kport
kT chnget "LT"
kT=kT+kTdev
  if kT<-12 then
  kT=-12
  elseif kT>12 then
  kT=12
  endif
kT portk kT,kport
kfmod=semitone(kT)

ksource chnget "Lsource"
key chnget "Lkey"

kpw chnget "pw"
kpw portk kpw,.02
kpwr chnget "pwr"
kpwd chnget "pwd"
kpwrr chnget "pwrr"
kpwrand randi kpwr*kpwrr,kpwr,2
kpwdev oscil kpwd,kpwr+kpwrand,1
kpw=kpw+kpwdev

kmod chnget "mod"
kmod portk kmod,.02
kmodr chnget "modr"
kmodd chnget "modd"
kmodrr chnget "modrr"
kmodrand randi kmodr*kmodrr,kmodr,2
kmoddev oscil kmodd,kmodr+kmodrand,1
kmod=kmod+kmoddev

kindex chnget "ind"
kindex portk kindex,.02
kindr chnget "indr"
kindd chnget "indd"
kindrr chnget "indrr"
kindrand randi kindr*kindrr,kindr,2
kinddev oscil kindd,kindr+kindrand,1
kindex=kindex+kinddev

knz chnget "Lnz"
krmsr,krmso,kerr,kcps lpread ktime,Sfilepath
kbzamp=(1-kerr)*kamp

;maybe add portamento for rmsr, rmso, err, and cps?

iMidiRef chnget "MidiRef"				; MIDI unison reference note

if key=2 then ;this little if-then assigns the pitch to the MIDI input if keyboard control is selected
kcps=cpsmidinn(iMidiRef+((p4-iMidiRef)*(12/i(gksc))))
endif

kcps portk kcps,.02
;oscillator function select logic
if ksource=1 then
;aout gbuzz kbzamp,kcps*kfmod,knh,klh,2 ;pulse--try both and figure out which to use in this implementation
aout vco2 kbzamp*.1,kcps*kfmod,6,0,0,.25 ;pulse
elseif ksource=2 then
aout vco2 kbzamp*.75,kcps*kfmod,0,0,0,.25 ;saw
elseif ksource=3 then
aout vco2 kbzamp*.75,kcps*kfmod,2,kpw,0,.25 ;square with PWM
elseif ksource=4 then
aout vco2 kbzamp*1.25,kcps*kfmod,4,kpw,0,.25 ;triangle/saw/ramp
elseif ksource=5 then
aout foscil kbzamp,kcps*kfmod,1,kmod,kindex*100,1
elseif ksource=6 then
kmod oscil kbzamp*kindex,kcps*kmod,1
aout vco2 kbzamp+kmod,kcps*kfmod,0,0,0,.25 ;using a sine modulator with analog saw
elseif ksource=7 then
aout rand kbzamp
elseif ksource=8 then
aout pinkish kbzamp*1.5
endif

afilt  lpreson aout
aout  balance afilt,aout*.1
asig  rand krmsr
asig=asig*kerr*knz*kamp
gasrcL=(aout+asig)+gasrcL
gasrcR=(aout+asig)+gasrcR
endin

instr 25 ;GUI control for PW rslider control, FM controls and AM controls, and Dynamic Filter CF Offset vs. Base
ksource chnget "Lsource"

if changed(ksource)==1 then
 if ksource==3 then ;Suare
  chnset "visible(1)", "pwid"
  chnset "visible(1)", "pwrid"
  chnset "visible(1)", "pwdid"
  chnset "visible(1)", "pwrrid"
  chnset "visible(1)", "pwidM"
  chnset "visible(1)", "pwridM"
  chnset "visible(1)", "pwdidM"
  chnset "visible(1)", "pwrridM"
  chnset "visible(1)", "pwidX"
  chnset "visible(1)", "pwridX"
  chnset "visible(1)", "pwdidX"
  chnset "visible(1)", "pwrridX"
  chnset "visible(0)", "modid"
  chnset "visible(0)", "modrid"
  chnset "visible(0)", "moddid"
  chnset "visible(0)", "modrrid"
  chnset "visible(0)", "modidM"
  chnset "visible(0)", "modridM"
  chnset "visible(0)", "moddidM"
  chnset "visible(0)", "modrridM"
  chnset "visible(0)", "modidX"
  chnset "visible(0)", "modridX"
  chnset "visible(0)", "moddidX"
  chnset "visible(0)", "modrridX"
  chnset "visible(0)", "indid"
  chnset "visible(0)", "indrid"
  chnset "visible(0)", "inddid"
  chnset "visible(0)", "indrrid"
  chnset "visible(0)", "indidM"
  chnset "visible(0)", "indridM"
  chnset "visible(0)", "inddidM"
  chnset "visible(0)", "indrridM"
  chnset "visible(0)", "indidX"
  chnset "visible(0)", "indridX"
  chnset "visible(0)", "inddidX"
  chnset "visible(0)", "indrridX"
 elseif ksource==4 then ;Triangle
  chnset "visible(1)", "pwid"
  chnset "visible(1)", "pwrid"
  chnset "visible(1)", "pwdid"
  chnset "visible(1)", "pwrrid"
  chnset "visible(1)", "pwidM"
  chnset "visible(1)", "pwridM"
  chnset "visible(1)", "pwdidM"
  chnset "visible(1)", "pwrridM"
  chnset "visible(1)", "pwidX"
  chnset "visible(1)", "pwridX"
  chnset "visible(1)", "pwdidX"
  chnset "visible(1)", "pwrridX"
  chnset "visible(0)", "modid"
  chnset "visible(0)", "modrid"
  chnset "visible(0)", "moddid"
  chnset "visible(0)", "modrrid"
  chnset "visible(0)", "modidM"
  chnset "visible(0)", "modridM"
  chnset "visible(0)", "moddidM"
  chnset "visible(0)", "modrridM"
  chnset "visible(0)", "modidX"
  chnset "visible(0)", "modridX"
  chnset "visible(0)", "moddidX"
  chnset "visible(0)", "modrridX"
  chnset "visible(0)", "indid"
  chnset "visible(0)", "indrid"
  chnset "visible(0)", "inddid"
  chnset "visible(0)", "indrrid"
  chnset "visible(0)", "indidM"
  chnset "visible(0)", "indridM"
  chnset "visible(0)", "inddidM"
  chnset "visible(0)", "indrridM"
  chnset "visible(0)", "indidX"
  chnset "visible(0)", "indridX"
  chnset "visible(0)", "inddidX"
  chnset "visible(0)", "indrridX"
 elseif ksource==5 then ;FM
  chnset "visible(0)", "pwid"
  chnset "visible(0)", "pwrid"
  chnset "visible(0)", "pwdid"
  chnset "visible(0)", "pwrrid"
  chnset "visible(0)", "pwidM"
  chnset "visible(0)", "pwridM"
  chnset "visible(0)", "pwdidM"
  chnset "visible(0)", "pwrridM"
  chnset "visible(0)", "pwidX"
  chnset "visible(0)", "pwridX"
  chnset "visible(0)", "pwdidX"
  chnset "visible(0)", "pwrridX"  
  chnset "visible(1)", "modid"
  chnset "visible(1)", "modrid"
  chnset "visible(1)", "moddid"
  chnset "visible(1)", "modrrid"
  chnset "visible(1)", "modidM"
  chnset "visible(1)", "modridM"
  chnset "visible(1)", "moddidM"
  chnset "visible(1)", "modrridM"
  chnset "visible(1)", "modidX"
  chnset "visible(1)", "modridX"
  chnset "visible(1)", "moddidX"
  chnset "visible(1)", "modrridX"
  chnset "visible(1)", "indid"
  chnset "visible(1)", "indrid"
  chnset "visible(1)", "inddid"
  chnset "visible(1)", "indrrid"
  chnset "visible(1)", "indidM"
  chnset "visible(1)", "indridM"
  chnset "visible(1)", "inddidM"
  chnset "visible(1)", "indrridM"
  chnset "visible(1)", "indidX"
  chnset "visible(1)", "indridX"
  chnset "visible(1)", "inddidX"
  chnset "visible(1)", "indrridX"
 elseif ksource==6 then ;AM
  chnset "visible(0)", "pwid"
  chnset "visible(0)", "pwrid"
  chnset "visible(0)", "pwdid"
  chnset "visible(0)", "pwrrid"
  chnset "visible(0)", "pwidM"
  chnset "visible(0)", "pwridM"
  chnset "visible(0)", "pwdidM"
  chnset "visible(0)", "pwrridM"
  chnset "visible(0)", "pwidX"
  chnset "visible(0)", "pwridX"
  chnset "visible(0)", "pwdidX"
  chnset "visible(0)", "pwrridX"  
  chnset "visible(1)", "modid"
  chnset "visible(1)", "modrid"
  chnset "visible(1)", "moddid"
  chnset "visible(1)", "modrrid"
  chnset "visible(1)", "modidM"
  chnset "visible(1)", "modridM"
  chnset "visible(1)", "moddidM"
  chnset "visible(1)", "modrridM"
  chnset "visible(1)", "modidX"
  chnset "visible(1)", "modridX"
  chnset "visible(1)", "moddidX"
  chnset "visible(1)", "modrridX"
  chnset "visible(1)", "indid"
  chnset "visible(1)", "indrid"
  chnset "visible(1)", "inddid"
  chnset "visible(1)", "indrrid"
  chnset "visible(1)", "indidM"
  chnset "visible(1)", "indridM"
  chnset "visible(1)", "inddidM"
  chnset "visible(1)", "indrridM"
  chnset "visible(1)", "indidX"
  chnset "visible(1)", "indridX"
  chnset "visible(1)", "inddidX"
  chnset "visible(1)", "indrridX"
 else
  chnset "visible(0)", "pwid"
  chnset "visible(0)", "pwrid"
  chnset "visible(0)", "pwdid"
  chnset "visible(0)", "pwrrid"
  chnset "visible(0)", "pwidM"
  chnset "visible(0)", "pwridM"
  chnset "visible(0)", "pwdidM"
  chnset "visible(0)", "pwrridM"
  chnset "visible(0)", "pwidX"
  chnset "visible(0)", "pwridX"
  chnset "visible(0)", "pwdidX"
  chnset "visible(0)", "pwrridX"    
  chnset "visible(0)", "modid"
  chnset "visible(0)", "modrid"
  chnset "visible(0)", "moddid"
  chnset "visible(0)", "modrrid"
  chnset "visible(0)", "modidM"
  chnset "visible(0)", "modridM"
  chnset "visible(0)", "moddidM"
  chnset "visible(0)", "modrridM"
  chnset "visible(0)", "modidX"
  chnset "visible(0)", "modridX"
  chnset "visible(0)", "moddidX"
  chnset "visible(0)", "modrridX"
  chnset "visible(0)", "indid"
  chnset "visible(0)", "indrid"
  chnset "visible(0)", "inddid"
  chnset "visible(0)", "indrrid"
  chnset "visible(0)", "indidM"
  chnset "visible(0)", "indridM"
  chnset "visible(0)", "inddidM"
  chnset "visible(0)", "indrridM"
  chnset "visible(0)", "indidX"
  chnset "visible(0)", "indridX"
  chnset "visible(0)", "inddidX"
  chnset "visible(0)", "indrridX"
 endif
endif
endin

instr 60 ;vocal filter preset controller
 gkvpreset	chnget	"vpresets"
 ktrig		changed	gkvpreset 

 #define SET_PRESET(N'set1'set2'set3'set4'set5'set6'set7'set8'set9'set10'set11'set12'set13'set14'set15'set16)
 #
 if i(gkvpreset)==$N then
  chnset	$set1,"parsel1"	  
  chnset	$set2,"parsel2"    
  chnset	$set3,"parsel3"   
  chnset	$set4,"parsel4"
  chnset	$set5,"parF1"
  chnset	$set6,"parF2"  
  chnset	$set7,"parF3"
  chnset	$set8,"parF4"
  chnset	$set9,"parres1"
  chnset	$set10,"parres2"
  chnset	$set11,"parres3"   
  chnset	$set12,"parres4"   
  chnset	$set13,"paramp1" 
  chnset	$set14,"paramp2" 
  chnset	$set15,"paramp3"
  chnset	$set16,"paramp4"
 endif
 #
 if ktrig==1 then
  reinit SEND_PRESET
 endif
 SEND_PRESET: ;1-21=default, Sop a,e,i,o,u, Alto a,e,i,o,u, Tenor a,e,i,o,u, and Bass a,e,i,o,u
 ;           N'set1'set2'set3'set4'set5'set6'set7'set8'set9'set10'set11'set12'set13'set14'set15'set16
 $SET_PRESET(1'1'2'2'3'8'9'10'11'1'1'1'1'1'1'1'1)
 $SET_PRESET(2'2'2'2'2'octmidinn(79.4)'octmidinn(85.6)'octmidinn(101.6)'octmidinn(106.85)'800/80'1150/120'2900/200'3900/130'ampdbfs(0)'ampdbfs(-6)'ampdbfs(-32)'ampdbfs(-20)) ;soprano
 $SET_PRESET(3'2'2'2'2'octmidinn(65)'octmidinn(95.2)'octmidinn(101.1)'octmidinn(105.45)'350/60'2000/100'2800/120'3600/150'ampdbfs(0)'ampdbfs(-20)'ampdbfs(-15)'ampdbfs(-40))
 $SET_PRESET(4'2'2'2'2'octmidinn(60.6)'octmidinn(96.4)'octmidinn(101.9)'octmidinn(106.85)'270/60'2140/90'2950/100'3900/120'ampdbfs(0)'ampdbfs(-12)'ampdbfs(-26)'ampdbfs(-26))
 $SET_PRESET(5'2'2'2'2'octmidinn(69.4)'octmidinn(79.4)'octmidinn(101.2)'octmidinn(106.4)'450/40'800/80'2830/100'3800/120'ampdbfs(0)'ampdbfs(-11)'ampdbfs(-22)'ampdbfs(-22))
 $SET_PRESET(6'2'2'2'2'octmidinn(63.75)'octmidinn(77)'octmidinn(100.45)'octmidinn(106.4)'325/50'700/60'2700/170'3800/180'ampdbfs(0)'ampdbfs(-16)'ampdbfs(-35)'ampdbfs(-40))
 $SET_PRESET(7'2'2'2'2'octmidinn(79.4)'octmidinn(85.6)'octmidinn(101.1)'octmidinn(104.9)'800/80'1150/90'2800/120'3500/130'ampdbfs(0)'ampdbfs(-4)'ampdbfs(-20)'ampdbfs(-36)) ;alto
 $SET_PRESET(8'2'2'2'2'octmidinn(67.4)'octmidinn(91.4)'octmidinn(100.45)'octmidinn(103.85)'400/60'1600/80'2700/120'3300/150'ampdbfs(0)'ampdbfs(-24)'ampdbfs(-30)'ampdbfs(-35))
 $SET_PRESET(9'2'2'2'2'octmidinn(65)'octmidinn(92.4)'octmidinn(100.45)'octmidinn(105.9)'350/50'1700/100'2700/120'3700/150'ampdbfs(0)'ampdbfs(-20)'ampdbfs(-30)'ampdbfs(-36))
 $SET_PRESET(10'2'2'2'2'octmidinn(69.4)'octmidinn(79.4)'octmidinn(101.2)'octmidinn(104.9)'450/70'800/80'2830/100'3500/130'ampdbfs(0)'ampdbfs(-9)'ampdbfs(-16)'ampdbfs(-28))
 $SET_PRESET(11'2'2'2'2'octmidinn(63.75)'octmidinn(77)'octmidinn(99.3)'octmidinn(104.9)'325/50'700/60'2530/170'3500/180'ampdbfs(0)'ampdbfs(-12)'ampdbfs(-30)'ampdbfs(-40))
 $SET_PRESET(12'2'2'2'2'octmidinn(75.75)'octmidinn(84.6)'octmidinn(100.1)'octmidinn(101.6)'650/80'1080/90'2650/120'2900/130'ampdbfs(0)'ampdbfs(-6)'ampdbfs(-7)'ampdbfs(-8)) ;tenor
 $SET_PRESET(13'2'2'2'2'octmidinn(67.4)'octmidinn(92.4)'octmidinn(99.7)'octmidinn(103.4)'400/70'1700/80'2600/100'3200/120'ampdbfs(0)'ampdbfs(-14)'ampdbfs(-12)'ampdbfs(-14))
 $SET_PRESET(14'2'2'2'2'octmidinn(61.66)'octmidinn(94.1)'octmidinn(101.1)'octmidinn(103.6)'290/40'1870/90'2800/100'3250/120'ampdbfs(0)'ampdbfs(-15)'ampdbfs(-18)'ampdbfs(-20))
 $SET_PRESET(15'2'2'2'2'octmidinn(67.4)'octmidinn(79.4)'octmidinn(99.7)'octmidinn(101.1)'400/70'800/80'2600/100'2800/130'ampdbfs(0)'ampdbfs(-10)'ampdbfs(-12)'ampdbfs(-12))
 $SET_PRESET(16'2'2'2'2'octmidinn(65)'octmidinn(74.3)'octmidinn(100.45)'octmidinn(101.6)'350/40'600/60'2700/100'2900/120'ampdbfs(0)'ampdbfs(-20)'ampdbfs(-17)'ampdbfs(-14))
 $SET_PRESET(17'2'2'2'2'octmidinn(74.3)'octmidinn(83.9)'octmidinn(97.2)'octmidinn(98.6)'600/60'1040/70'2250/110'2450/120'ampdbfs(0)'ampdbfs(-7)'ampdbfs(-9)'ampdbfs(-9)) ;bass
 $SET_PRESET(18'2'2'2'2'octmidinn(67.4)'octmidinn(91.6)'octmidinn(98.4)'octmidinn(101.1)'400/40'1620/80'2400/100'2800/120'ampdbfs(0)'ampdbfs(-12)'ampdbfs(-9)'ampdbfs(-12))
 $SET_PRESET(19'2'2'2'2'octmidinn(59.33)'octmidinn(92.9)'octmidinn(99.7)'octmidinn(102.5)'250/60'1750/90'2600/100'3050/120'ampdbfs(0)'ampdbfs(-30)'ampdbfs(-16)'ampdbfs(-22))
 $SET_PRESET(20'2'2'2'2'octmidinn(67.4)'octmidinn(78.25)'octmidinn(98.4)'octmidinn(99.7)'400/40'750/80'2400/100'2600/120'ampdbfs(0)'ampdbfs(-11)'ampdbfs(-21)'ampdbfs(-20))
 $SET_PRESET(21'2'2'2'2'octmidinn(65)'octmidinn(74.3)'octmidinn(98.4)'octmidinn(100.3)'350/40'600/80'2400/100'2675/120'ampdbfs(0)'ampdbfs(-20)'ampdbfs(-32)'ampdbfs(-28))
endin

instr 61 ;Transposer preset controller
 gkTpreset	chnget	"Tpresets"
 ktrig		changed	gkTpreset 

 #define SET_PRESET(N'set1'set2'set3'set4'set5'set6'set7'set8'set9'set10'set11'set12)
 #
 if i(gkTpreset)==$N then
  chnset	$set1,"harmon1C"	  
  chnset	$set2,"harmon1F"    
  chnset	$set3,"harmon2C"   
  chnset	$set4,"harmon2F"
  chnset	$set5,"harmon3C"
  chnset	$set6,"harmon3F"  
  chnset	$set7,"harmon4C"
  chnset	$set8,"harmon4F"
  chnset	$set9,"harmon5C"
  chnset	$set10,"harmon5F"
  chnset	$set11,"harmon6C"   
  chnset	$set12,"harmon6F"
 endif
 #
 if ktrig==1 then
  reinit SEND_PRESET
 endif
 SEND_PRESET:
 ;           N'set1'set2'set3'set4'set5'set6'set7'set8'set9'set10'set11'set12'set13'set14'set15'set16
 $SET_PRESET(1'0'.14'0'-.16'0'.09'0'-.12'0'.11'0'-.05)
 $SET_PRESET(2'0'.15'0'-.16'0'.18'0'-.25'0'.24'0'-.21)
 $SET_PRESET(3'0'-.32'0'.67'0'-.65'-1'.01'1'-.06'0'.34)
 $SET_PRESET(4'7'-.05'7'.1'7'-.08'7'.01'7'-.06'7'.03)
 $SET_PRESET(5'5'.05'5'-.1'5'.08'5'-.03'5'.06'5'-.05)
 $SET_PRESET(6'4'-.07'4'.04'4'-.02'4'.06'4'-.08'4'.09)
 $SET_PRESET(7'3'.05'3'.11'3'.08'3'-.01'3'-.06'3'-.09)
 $SET_PRESET(8'0'.5'0'-.5'1'0'-1'.01'1'-.51'-1'.53)
 $SET_PRESET(9'-1'-.05'1'.1'-2'-.08'2'.01'-3'-.06'3'.03)
 $SET_PRESET(10'4'-.05'-4'.1'6'-.08'-6'.01'2'-.06'-2'.03)
 $SET_PRESET(11'21'-.05'-21'.1'7'-.08'-7'.01'14'-.06'-14'.03)
 $SET_PRESET(12'-10'-.05'10'.1'-15'-.08'15'.01'-5'-.06'5'.03)
 $SET_PRESET(13'4'-.05'-4'.1'12'-.08'-12'.01'8'-.06'-8'.03)
 $SET_PRESET(14'-9'-.05'9'.1'-6'-.08'6'.01'-3'-.06'3'.03)
 $SET_PRESET(15'-12'-.15'-24'.19'-12'-.18'24'.17'12'-.16'12'.13)
 $SET_PRESET(16'-12'-.05'-5'.1'-12'-.08'-5'.01'7'-.06'12'.03)
 $SET_PRESET(17'16'-.05'-12'.1'7'-.08'-5'.01'12'-.06'-12'.03)
 $SET_PRESET(18'12'-.05'-5'.1'3'-.08'-12'.01'7'-.06'15'.03)
 $SET_PRESET(19'4'-.05'12'.1'10'-.08'-12'.01'-5'-.06'10'.03)
 $SET_PRESET(20'7'-.05'-12'.1'-5'-.08'11'.01'4'-.06'12'.03)
 $SET_PRESET(21'11'-.05'4'.1'12'-.08'2'.01'-12'-.06'-5'.03)
 $SET_PRESET(22'10'-.05'12'.1'7'-.08'3'.01'-5'-.06'-12'.03)
 $SET_PRESET(23'-12'-.05'-5'.1'5'-.08'7'.01'0'-.06'12'.03)
 $SET_PRESET(24'7'-.05'10'.1'12'-.08'-12'.01'-5'-.06'5'.03)
 $SET_PRESET(25'12'-.05'10'.1'-12'-.08'-5'.01'4'-.06'15'.03)
 $SET_PRESET(26'10'-.05'-12'.1'12'-.08'4'.01'-5'-.06'14'.03)
 $SET_PRESET(27'0'-.05'4'.1'-12'-.08'10'.01'15'-.06'4'.03)
endin

instr 100   ;instrument to monitor MIDI controller numbers, creates global MIDI outputs that are evaluated by instr 110-300         
            ;also controls popup for latched LowPass and soundfile string management
gkstatus,gkchan,gkdata1,gkdata2 midiin
if changed(gkstatus)==1 then  
    if gkstatus==176 then
    chnset gkdata1,"CtrlNum" ;displays current controller number in GUI
    endif
endif
endin

instr 110 ;receive MIDI mapping buttons for pvoc
kmappointer chnget "mappointer"
kmappointerX chnget "mappointerX"
kmapT chnget "mapT"
kmapTX chnget "mapTX"
kmapamp chnget "mapamp"
kmapampX chnget "mapampX"
kmapstart chnget "mapstart"
kmapstartX chnget "mapstartX"
kmapend chnget "mapend"
kmapendX chnget "mapendX"
kmapdur chnget "mapdur"
kmapdurX chnget "mapdurX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmappointer == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 111, 2, 0
            event "i", 111, 0, 999999999
        elseif kmapT == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 112, 2, 0
            event "i", 112, 0, 999999999
        elseif kmapamp == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 113, 2, 0
            event "i", 113, 0, 999999999
        elseif kmapstart == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 114, 2, 0
            event "i", 114, 0, 999999999
        elseif kmapend == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 115, 2, 0
            event "i", 115, 0, 999999999
        elseif kmapdur == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 116, 2, 0
            event "i", 116, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmappointerX == 1 then
    turnoff2 111, 2, 0
elseif kmapTX == 1 then
    turnoff2 112, 2, 0
elseif kmapampX == 1 then
    turnoff2 113, 2, 0
elseif kmapstartX == 1 then
    turnoff2 114, 2, 0
elseif kmapendX == 1 then
    turnoff2 115, 2, 0
elseif kmapdurX == 1 then
    turnoff2 116, 2, 0
endif
endin

instr 111 ;MIDI mapping for pvoc
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "pointer"
endin

instr 112 ;MIDI mapping for pvoc
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-12,12 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "T"
endin

instr 113 ;MIDI mapping for pvoc
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,2 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "amp"
endin

instr 114 ;MIDI mapping for pvoc
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,10 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "start"
endin

instr 115 ;MIDI mapping for pvoc
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,10 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "end"
endin

instr 116 ;MIDI mapping for pvoc
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,100 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "dur"
endin

instr 350 ;MIDI mapping for pv random
kmappvport chnget "mappvport"
kmappvportX chnget "mappvportX"
kmappvtimer chnget "mappvtimer"
kmappvtimerX chnget "mappvtimerX"
kmappvtimed chnget "mappvtimed"
kmappvtimedX chnget "mappvtimedX"
kmappvTr chnget "mappvTr"
kmappvTrX chnget "mappvTrX"
kmappvTd chnget "mappvTd"
kmappvTdX chnget "mappvTdX"
kmappvrr chnget "mappvrr"
kmappvrrX chnget "mappvrrX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmappvport == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 351, 2, 0
            event "i", 351, 0, 999999999
        elseif kmappvtimer == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 352, 2, 0
            event "i", 352, 0, 999999999
        elseif kmappvtimed == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 353, 2, 0
            event "i", 353, 0, 999999999
        elseif kmappvTr == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 354, 2, 0
            event "i", 354, 0, 999999999
        elseif kmappvTd == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 355, 2, 0
            event "i", 355, 0, 999999999
        elseif kmappvrr == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 356, 2, 0
            event "i", 356, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmappvportX == 1 then
    turnoff2 351, 2, 0
elseif kmappvtimerX == 1 then
    turnoff2 352, 2, 0
elseif kmappvtimedX == 1 then
    turnoff2 353, 2, 0
elseif kmappvTrX == 1 then
    turnoff2 354, 2, 0
elseif kmappvTdX == 1 then
    turnoff2 355, 2, 0
elseif kmappvrrX == 1 then
    turnoff2 356, 2, 0
endif
endin

instr 351 ;MIDI mapping for pvoc
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,2 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "pvport"
endin

instr 352 ;MIDI mapping for pvoc
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,100 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "pvtimer"
endin

instr 353 ;MIDI mapping for pvoc
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "pvtimed"
endin

instr 354 ;MIDI mapping for pvoc
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,100 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "pvTr"
endin

instr 355 ;MIDI mapping for pvoc
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,12 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "pvTd"
endin

instr 356 ;MIDI mapping for pvoc
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.95 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "pvrr"

endin

instr 120
;receive MIDI mapping buttons for adsyn
kmapHspeed chnget "mapHspeed"
kmapHspeedX chnget "mapHspeedX"
kmapHT chnget "mapHT"
kmapHTX chnget "mapHTX"
kmapHamp chnget "mapHamp"
kmapHampX chnget "mapHampX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapHspeed == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 121, 2, 0
            event "i", 121, 0, 999999999
        elseif kmapHT == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 122, 2, 0
            event "i", 122, 0, 999999999
        elseif kmapHamp == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 123, 2, 0
            event "i", 123, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapHspeedX == 1 then
    turnoff2 121, 2, 0
elseif kmapHTX == 1 then
    turnoff2 122, 2, 0
elseif kmapHampX == 1 then
    turnoff2 123, 2, 0
endif
endin

instr 121 ;MIDI mapping for adsyn
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,3 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Hspeed"
endin

instr 122 ;MIDI mapping for adsyn
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-12,12 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "HT"
endin

instr 123 ;MIDI mapping for adsyn
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,2 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Hamp"
endin

instr 130
;receive MIDI mapping buttons for lp
kmapLpointer chnget "mapLpointer"
kmapLpointerX chnget "mapLpointerX"
kmapLT chnget "mapLT"
kmapLTX chnget "mapLTX"
kmapLamp chnget "mapLamp"
kmapLampX chnget "mapLampX"
kmapLstart chnget "mapLstart"
kmapLstartX chnget "mapLstartX"
kmapLend chnget "mapLend"
kmapLendX chnget "mapLendX"
kmapLdur chnget "mapLdur"
kmapLdurX chnget "mapLdurX"
kmappw chnget "mappw"
kmappwX chnget "mappwX"
kmappwr chnget "mappwr"
kmappwrX chnget "mappwrX"
kmappwd chnget "mappwd"
kmappwdX chnget "mappwdX"
kmappwrr chnget "mappwrr"
kmappwrrX chnget "mappwrrX"
kmapmod chnget "mapmod"
kmapmodX chnget "mapmodX"
kmapmodr chnget "mapmodr"
kmapmodrX chnget "mapmodrX"
kmapmodd chnget "mapmodd"
kmapmoddX chnget "mapmoddX"
kmapmodrr chnget "mapmodrr"
kmapmodrrX chnget "mapmodrrX"
kmapind chnget "mapind"
kmapindX chnget "mapindX"
kmapindr chnget "mapindr"
kmapindrX chnget "mapindrX"
kmapindd chnget "mapindd"
kmapinddX chnget "mapinddX"
kmapindrr chnget "mapindrr"
kmapindrrX chnget "mapindrrX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapLpointer == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 131, 2, 0
            event "i", 131, 0, 999999999
        elseif kmapLT == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 132, 2, 0
            event "i", 132, 0, 999999999
        elseif kmapLamp == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 133, 2, 0
            event "i", 133, 0, 999999999
        elseif kmapLstart == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 134, 2, 0
            event "i", 134, 0, 999999999
        elseif kmapLend == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 135, 2, 0
            event "i", 135, 0, 999999999
        elseif kmapLdur == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 136, 2, 0
            event "i", 136, 0, 999999999
        elseif kmappw == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 137, 2, 0
            event "i", 137, 0, 999999999
        elseif kmappwr == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 138, 2, 0
            event "i", 138, 0, 999999999
        elseif kmappwd == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 139, 2, 0
            event "i", 139, 0, 999999999
        elseif kmappwrr == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 140, 2, 0
            event "i", 140, 0, 999999999
        elseif kmapmod == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 141, 2, 0
            event "i", 141, 0, 999999999
        elseif kmapmodr == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 142, 2, 0
            event "i", 142, 0, 999999999
        elseif kmapmodd == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 143, 2, 0
            event "i", 143, 0, 999999999
        elseif kmapmodrr == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 144, 2, 0
            event "i", 144, 0, 999999999
        elseif kmapind == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 145, 2, 0
            event "i", 145, 0, 999999999
        elseif kmapindr == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 146, 2, 0
            event "i", 146, 0, 999999999
        elseif kmapindd == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 147, 2, 0
            event "i", 147, 0, 999999999
        elseif kmapindrr == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 148, 2, 0
            event "i", 148, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapLpointerX == 1 then
    turnoff2 131, 2, 0
elseif kmapLTX == 1 then
    turnoff2 132, 2, 0
elseif kmapLampX == 1 then
    turnoff2 133, 2, 0
elseif kmapLstartX == 1 then
    turnoff2 134, 2, 0
elseif kmapLendX == 1 then
    turnoff2 135, 2, 0
elseif kmapLdurX == 1 then
    turnoff2 136, 2, 0
elseif kmappwX == 1 then
    turnoff2 137, 2, 0
elseif kmappwrX == 1 then
    turnoff2 138, 2, 0
elseif kmappwdX == 1 then
    turnoff2 139, 2, 0
elseif kmappwrrX == 1 then
    turnoff2 140, 2, 0
elseif kmapmodX == 1 then
    turnoff2 141, 2, 0
elseif kmapmodrX == 1 then
    turnoff2 142, 2, 0
elseif kmapmoddX == 1 then
    turnoff2 143, 2, 0
elseif kmapmodrrX == 1 then
    turnoff2 144, 2, 0
elseif kmapindX == 1 then
    turnoff2 145, 2, 0
elseif kmapindrX == 1 then
    turnoff2 146, 2, 0
elseif kmapinddX == 1 then
    turnoff2 147, 2, 0
elseif kmapindrrX == 1 then
    turnoff2 148, 2, 0
endif
endin

instr 131 ;MIDI mapping for lp
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Lpointer"
endin

instr 132 ;MIDI mapping for lp
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-12,12 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "LT"
endin

instr 133 ;MIDI mapping for lp
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,2 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Lamp"
endin

instr 134 ;MIDI mapping for lp
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,10 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Lstart"
endin

instr 135 ;MIDI mapping for lp
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,10 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Lend"
endin

instr 136 ;MIDI mapping for lp
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,10 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Ldur"
endin

instr 137 ;MIDI mapping for lp
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.05,.95 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "pw"
endin

instr 138 ;MIDI mapping for lp
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,50 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "pwr"
endin

instr 139 ;MIDI mapping for lp
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.75 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "pwd"
endin

instr 140 ;MIDI mapping for lp
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.95 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "pwrr"
endin

instr 141 ;MIDI mapping for lp
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.05,10 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "mod"
endin

instr 142 ;MIDI mapping for lp
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,50 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "modr"
endin

instr 143 ;MIDI mapping for lp
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.95 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "modd"
endin

instr 144 ;MIDI mapping for lp
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.95 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "modrr"
endin

instr 145 ;MIDI mapping for lp
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "ind"
endin

instr 146 ;MIDI mapping for lp
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,50 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "indr"
endin

instr 147 ;MIDI mapping for lp
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.95 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "indd"
endin

instr 148 ;MIDI mapping for lp
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.95 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "indrr"
endin

instr 360 ;MIDI mapping for L random
kmapLport chnget "mapLport"
kmapLportX chnget "mapLportX"
kmapLtimer chnget "mapLtimer"
kmapLtimerX chnget "mapLtimerX"
kmapLtimed chnget "mapLtimed"
kmapLtimedX chnget "mapLtimedX"
kmapLTr chnget "mapLTr"
kmapLTrX chnget "mapLTrX"
kmapLTd chnget "mapLTd"
kmapLTdX chnget "mapLTdX"
kmapLrr chnget "mapLrr"
kmapLrrX chnget "mapLrrX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapLport == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 361, 2, 0
            event "i", 361, 0, 999999999
        elseif kmapLtimer == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 362, 2, 0
            event "i", 362, 0, 999999999
        elseif kmapLtimed == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 363, 2, 0
            event "i", 363, 0, 999999999
        elseif kmapLTr == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 364, 2, 0
            event "i", 364, 0, 999999999
        elseif kmapLTd == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 365, 2, 0
            event "i", 365, 0, 999999999
        elseif kmapLrr == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 366, 2, 0
            event "i", 366, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapLportX == 1 then
    turnoff2 361, 2, 0
elseif kmapLtimerX == 1 then
    turnoff2 362, 2, 0
elseif kmapLtimedX == 1 then
    turnoff2 363, 2, 0
elseif kmapLTrX == 1 then
    turnoff2 364, 2, 0
elseif kmapLTdX == 1 then
    turnoff2 365, 2, 0
elseif kmapLrrX == 1 then
    turnoff2 366, 2, 0
endif
endin

instr 361 ;MIDI mapping for L
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,2 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Lport"
endin

instr 362 ;MIDI mapping for L
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,100 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Ltimer"
endin

instr 363 ;MIDI mapping for L
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Ltimed"
endin

instr 364 ;MIDI mapping for L
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,100 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "LTr"
endin

instr 365 ;MIDI mapping for L
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,12 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "LTd"
endin

instr 366 ;MIDI mapping for L
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.95 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Lrr"
endin

instr 320
;receive MIDI mapping buttons for Shift, Warp and Smooth
kmapshift chnget "mapshift"
kmapshiftX chnget "mapshiftX"
kmaplowest chnget "maplowest"
kmaplowestX chnget "maplowestX"
kmapshiftmix chnget "mapshiftmix"
kmapshiftmixX chnget "mapshiftmixX"
kmapenvscale chnget "mapenvscale"
kmapenvscaleX chnget "mapenvscaleX"
kmapenvshift chnget "mapenvshift"
kmapenvshiftX chnget "mapenvshiftX"
kmapenvlowest chnget "mapenvlowest"
kmapenvlowestX chnget "mapenvlowestX"
kmapwarpmix chnget "mapwarpmix"
kmapwarpmixX chnget "mapwarpmixX"
kmapampsmooth chnget "mapampsmooth"
kmapampsmoothX chnget "mapampsmoothX"
kmapfreqsmooth chnget "mapfreqsmooth"
kmapfreqsmoothX chnget "mapfreqsmoothX"
kmapsmoothmix chnget "mapsmoothmix"
kmapsmoothmixX chnget "mapsmoothmixX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapshift == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 321, 2, 0
            event "i", 321, 0, 999999999
        elseif kmaplowest == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 322, 2, 0
            event "i", 322, 0, 999999999
        elseif kmapshiftmix == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 323, 2, 0
            event "i", 323, 0, 999999999
        elseif kmapenvscale == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 324, 2, 0
            event "i", 324, 0, 999999999
        elseif kmapenvshift == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 325, 2, 0
            event "i", 325, 0, 999999999
        elseif kmapenvlowest == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 326, 2, 0
            event "i", 326, 0, 999999999
        elseif kmapwarpmix == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 327, 2, 0
            event "i", 327, 0, 999999999
        elseif kmapampsmooth == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 328, 2, 0
            event "i", 328, 0, 999999999
        elseif kmapfreqsmooth == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 329, 2, 0
            event "i", 329, 0, 999999999
        elseif kmapsmoothmix == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 330, 2, 0
            event "i", 330, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapshiftX == 1 then
    turnoff2 321, 2, 0
elseif kmaplowestX == 1 then
    turnoff2 322, 2, 0
elseif kmapshiftmixX == 1 then
    turnoff2 323, 2, 0
elseif kmapenvscaleX == 1 then
    turnoff2 324, 2, 0
elseif kmapenvshiftX == 1 then
    turnoff2 325, 2, 0
elseif kmapenvlowestX == 1 then
    turnoff2 326, 2, 0
elseif kmapwarpmixX == 1 then
    turnoff2 327, 2, 0
elseif kmapampsmoothX == 1 then
    turnoff2 328, 2, 0
elseif kmapfreqsmoothX == 1 then
    turnoff2 329, 2, 0
elseif kmapsmoothmixX == 1 then
    turnoff2 330, 2, 0
endif
endin

instr 321 ;MIDI mapping for Shift, Warp and Smooth
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "shift"
endin

instr 322 ;MIDI mapping for Shift, Warp and Smooth
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "lowest"
endin

instr 323 ;MIDI mapping for Shift, Warp and Smooth
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "shiftmix"
endin

instr 324 ;MIDI mapping for Shift, Warp and Smooth
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.1,10 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "envscale"
endin

instr 325 ;MIDI mapping for Shift, Warp and Smooth
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "envshift"
endin

instr 326 ;MIDI mapping for Shift, Warp and Smooth
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "envlowest"
endin

instr 327 ;MIDI mapping for Shift, Warp and Smooth
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "warpmix"
endin

instr 328 ;MIDI mapping for Shift, Warp and Smooth
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "ampsmooth"
endin

instr 329 ;MIDI mapping for Shift, Warp and Smooth
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "freqsmooth"
endin

instr 330 ;MIDI mapping for Shift, Warp and Smooth
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "smoothmix"
endin

instr 340
;receive MIDI mapping buttons for Arp1
kmaparpbin1 chnget "maparpbin1"
kmaparpbin1X chnget "maparpbin1X"
kmaparpdepth1 chnget "maparpdepth1"
kmaparpdepth1X chnget "maparpdepth1X"
kmaparpgain1 chnget "maparpgain1"
kmaparpgain1X chnget "maparpgain1X"
kmaparpwidth1 chnget "maparpwidth1"
kmaparpwidth1X chnget "maparpwidth1X"
kmaparpspeed1 chnget "maparpspeed1"
kmaparpspeed1X chnget "maparpspeed1X"
kmaparpamp1 chnget "maparpamp1"
kmaparpamp1X chnget "maparpamp1X"
kmaparprand1 chnget "maparprand1"
kmaparprand1X chnget "maparprand1X"
kmaparpmix chnget "maparpmix"
kmaparpmixX chnget "maparpmixX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmaparpbin1 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 341, 2, 0
            event "i", 341, 0, 999999999
        elseif kmaparpdepth1 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 342, 2, 0
            event "i", 342, 0, 999999999
        elseif kmaparpgain1 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 343, 2, 0
            event "i", 343, 0, 999999999
        elseif kmaparpwidth1 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 344, 2, 0
            event "i", 344, 0, 999999999
        elseif kmaparpspeed1 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 345, 2, 0
            event "i", 345, 0, 999999999
        elseif kmaparpamp1 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 346, 2, 0
            event "i", 346, 0, 999999999
        elseif kmaparprand1 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 347, 2, 0
            event "i", 347, 0, 999999999
        elseif kmaparpmix == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 348, 2, 0
            event "i", 348, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmaparpbin1X == 1 then
    turnoff2 341, 2, 0
elseif kmaparpdepth1X == 1 then
    turnoff2 342, 2, 0
elseif kmaparpgain1X == 1 then
    turnoff2 343, 2, 0
elseif kmaparpwidth1X == 1 then
    turnoff2 344, 2, 0
elseif kmaparpspeed1X == 1 then
    turnoff2 345, 2, 0
elseif kmaparpamp1X == 1 then
    turnoff2 346, 2, 0
elseif kmaparprand1X == 1 then
    turnoff2 347, 2, 0
elseif kmaparpmixX == 1 then
    turnoff2 348, 2, 0
endif
endin

instr 341 ;MIDI mapping for Arp1
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "arpbin1"
endin

instr 342 ;MIDI mapping for Arp1
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,10 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "arpdepth1"
endin

instr 343 ;MIDI mapping for Arp1
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,100 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "arpgain1"
endin

instr 344 ;MIDI mapping for Arp1
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "arpwidth1"
endin

instr 345 ;MIDI mapping for Arp1
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,100 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "arpspeed1"
endin

instr 346 ;MIDI mapping for Arp1
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "arpamp1"
endin

instr 347 ;MIDI mapping for Arp1
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "arprand1"
endin

instr 348 ;MIDI mapping for Arp1
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "arpmix"
endin

instr 150
;receive MIDI mapping buttons for Arp2
kmaparpbin2 chnget "maparpbin2"
kmaparpbin2X chnget "maparpbin2X"
kmaparpdepth2 chnget "maparpdepth2"
kmaparpdepth2X chnget "maparpdepth2X"
kmaparpgain2 chnget "maparpgain2"
kmaparpgain2X chnget "maparpgain2X"
kmaparpwidth2 chnget "maparpwidth2"
kmaparpwidth2X chnget "maparpwidth2X"
kmaparpspeed2 chnget "maparpspeed2"
kmaparpspeed2X chnget "maparpspeed2X"
kmaparpamp2 chnget "maparpamp2"
kmaparpamp2X chnget "maparpamp2X"
kmaparprand2 chnget "maparprand2"
kmaparprand2X chnget "maparprand2X"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmaparpbin2 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 151, 2, 0
            event "i", 151, 0, 999999999
        elseif kmaparpdepth2 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 152, 2, 0
            event "i", 152, 0, 999999999
        elseif kmaparpgain2 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 153, 2, 0
            event "i", 153, 0, 999999999
        elseif kmaparpwidth2 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 154, 2, 0
            event "i", 154, 0, 999999999
        elseif kmaparpspeed2 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 155, 2, 0
            event "i", 155, 0, 999999999
        elseif kmaparpamp2 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 156, 2, 0
            event "i", 156, 0, 999999999
        elseif kmaparprand2 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 157, 2, 0
            event "i", 157, 0, 999999999            
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmaparpbin2X == 1 then
    turnoff2 151, 2, 0
elseif kmaparpdepth2X == 1 then
    turnoff2 152, 2, 0
elseif kmaparpgain2X == 1 then
    turnoff2 153, 2, 0
elseif kmaparpwidth2X == 1 then
    turnoff2 154, 2, 0
elseif kmaparpspeed2X == 1 then
    turnoff2 155, 2, 0
elseif kmaparpamp2X == 1 then
    turnoff2 156, 2, 0
elseif kmaparprand2X == 1 then
    turnoff2 157, 2, 0    
endif
endin

instr 151 ;MIDI mapping for Arp2
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "arpbin2"
endin

instr 152 ;MIDI mapping for Arp2
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,10 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "arpdepth2"
endin

instr 153 ;MIDI mapping for Arp2
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,100 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "arpgain2"
endin

instr 154 ;MIDI mapping for Arp2
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "arpwidth2"
endin

instr 155 ;MIDI mapping for Arp2
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,100 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "arpspeed2"
endin

instr 156 ;MIDI mapping for Arp1
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "arpamp2"
endin

instr 157 ;MIDI mapping for Arp1
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "arprand2"
endin

instr 160
;receive MIDI mapping buttons for Arp3
kmaparpbin3 chnget "maparpbin3"
kmaparpbin3X chnget "maparpbin3X"
kmaparpdepth3 chnget "maparpdepth3"
kmaparpdepth3X chnget "maparpdepth3X"
kmaparpgain3 chnget "maparpgain3"
kmaparpgain3X chnget "maparpgain3X"
kmaparpwidth3 chnget "maparpwidth3"
kmaparpwidth3X chnget "maparpwidth3X"
kmaparpspeed3 chnget "maparpspeed3"
kmaparpspeed3X chnget "maparpspeed3X"
kmaparpamp3 chnget "maparpamp3"
kmaparpamp3X chnget "maparpamp3X"
kmaparprand3 chnget "maparprand3"
kmaparprand3X chnget "maparprand3X"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmaparpbin3 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 161, 2, 0
            event "i", 161, 0, 999999999
        elseif kmaparpdepth3 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 162, 2, 0
            event "i", 162, 0, 999999999
        elseif kmaparpgain3 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 163, 2, 0
            event "i", 163, 0, 999999999
        elseif kmaparpwidth3 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 164, 2, 0
            event "i", 164, 0, 999999999
        elseif kmaparpspeed3 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 165, 2, 0
            event "i", 165, 0, 999999999
        elseif kmaparpamp3 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 166, 2, 0
            event "i", 166, 0, 999999999
        elseif kmaparprand3 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 167, 2, 0
            event "i", 167, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmaparpbin3X == 1 then
    turnoff2 161, 2, 0
elseif kmaparpdepth3X == 1 then
    turnoff2 162, 2, 0
elseif kmaparpgain3X == 1 then
    turnoff2 163, 2, 0
elseif kmaparpwidth3X == 1 then
    turnoff2 164, 2, 0
elseif kmaparpspeed3X == 1 then
    turnoff2 165, 2, 0
elseif kmaparpamp3X == 1 then
    turnoff2 166, 2, 0
elseif kmaparprand3X == 1 then
    turnoff2 167, 2, 0
endif
endin

instr 161 ;MIDI mapping for Arp3
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "arpbin3"
endin

instr 162 ;MIDI mapping for Arp3
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,10 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "arpdepth3"
endin

instr 163 ;MIDI mapping for Arp3
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,100 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "arpgain3"
endin

instr 164 ;MIDI mapping for Arp3
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "arpwidth3"
endin

instr 165 ;MIDI mapping for Arp3
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,100 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "arpspeed3"
endin

instr 166 ;MIDI mapping for Arp3
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "arpamp3"
endin

instr 167 ;MIDI mapping for Arp3
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "arprand3"
endin

instr 210
;receive MIDI mapping buttons for Distortion
kmapdist chnget "mapdist"
kmapdistX chnget "mapdistX"
kmapdist2 chnget "mapdist2"
kmapdist2X chnget "mapdist2X"
kmapdist3 chnget "mapdist3"
kmapdist3X chnget "mapdist3X"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapdist == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 211, 2, 0
            event "i", 211, 0, 999999999
        elseif kmapdist2 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 212, 2, 0
            event "i", 212, 0, 999999999
        elseif kmapdist3 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 213, 2, 0
            event "i", 213, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapdistX == 1 then
    turnoff2 211, 2, 0
elseif kmapdist2X == 1 then
    turnoff2 212, 2, 0
elseif kmapdist3X == 1 then
    turnoff2 213, 2, 0
endif
endin

instr 211 ;MIDI mapping for Distortion
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "dist"
endin

instr 212 ;MIDI mapping for Distortion
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.999 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "dist2"
endin

instr 213 ;MIDI mapping for Distortion
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,1,25 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "dist3"
endin

instr 230
;receive MIDI mapping buttons for Lowpass
kmapLPcps chnget "mapLPcps"
kmapLPcpsX chnget "mapLPcpsX"
kmapLPres chnget "mapLPres"
kmapLPresX chnget "mapLPresX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapLPcps == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 231, 2, 0
            event "i", 231, 0, 999999999
        elseif kmapLPres == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 232, 2, 0
            event "i", 232, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapLPcpsX == 1 then
    turnoff2 231, 2, 0
elseif kmapLPresX == 1 then
    turnoff2 232, 2, 0
endif
endin

instr 231 ;MIDI mapping for Lowpass
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,2,14 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "LPcps"
endin

instr 232 ;MIDI mapping for Lowpass
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,.99 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "LPres"
endin

instr 240
;receive MIDI mapping buttons for Phaser
kmapphscps chnget "mapphscps"
kmapphscpsX chnget "mapphscpsX"
kmapphsFB chnget "mapphsFB"
kmapphsFBX chnget "mapphsFBX"
kmapphsQ chnget "mapphsQ"
kmapphsQX chnget "mapphsQX"


;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapphscps == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 241, 2, 0
            event "i", 241, 0, 999999999
        elseif kmapphsFB == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 242, 2, 0
            event "i", 242, 0, 999999999
        elseif kmapphsQ == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 243, 2, 0
            event "i", 243, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapphscpsX == 1 then
    turnoff2 241, 2, 0
elseif kmapphsFBX == 1 then
    turnoff2 242, 2, 0
elseif kmapphsQX == 1 then
    turnoff2 243, 2, 0
endif
endin

instr 241 ;MIDI mapping for Phaser
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,100 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "phscps"
endin

instr 242 ;MIDI mapping for Phaser
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "phsFB"
endin

instr 243 ;MIDI mapping for Phaser
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,100 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "phsQ"
endin

instr 250
;receive MIDI mapping buttons for Flanger
kmapflcps chnget "mapflcps"
kmapflcpsX chnget "mapflcpsX"
kmapflFB chnget "mapflFB"
kmapflFBX chnget "mapflFBX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapflcps == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 251, 2, 0
            event "i", 251, 0, 999999999
        elseif kmapflFB == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 252, 2, 0
            event "i", 252, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapflcpsX == 1 then
    turnoff2 251, 2, 0
elseif kmapflFBX == 1 then
    turnoff2 252, 2, 0
endif
endin

instr 251 ;MIDI mapping for Flanger
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,100 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "flcps"
endin

instr 252 ;MIDI mapping for Flanger
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.99 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "flFB"
endin

instr 260
;receive MIDI mapping buttons for Transposer
kmapharmmix chnget "mapharmmix"
kmapharmmixX chnget "mapharmmixX"
kmapharmon1C chnget "mapharmon1C"
kmapharmon1CX chnget "mapharmon1CX"
kmapharmon1F chnget "mapharmon1F"
kmapharmon1FX chnget "mapharmon1FX"
kmapharmon2C chnget "mapharmon2C"
kmapharmon2CX chnget "mapharmon2CX"
kmapharmon2F chnget "mapharmon2F"
kmapharmon2FX chnget "mapharmon2FX"
kmapharmon3C chnget "mapharmon3C"
kmapharmon3CX chnget "mapharmon3CX"
kmapharmon3F chnget "mapharmon3F"
kmapharmon3FX chnget "mapharmon3FX"
kmapharmon4C chnget "mapharmon4C"
kmapharmon4CX chnget "mapharmon4CX"
kmapharmon4F chnget "mapharmon4F"
kmapharmon4FX chnget "mapharmon4FX"
kmapharmon5C chnget "mapharmon5C"
kmapharmon5CX chnget "mapharmon5CX"
kmapharmon5F chnget "mapharmon5F"
kmapharmon5FX chnget "mapharmon5FX"
kmapharmon6C chnget "mapharmon6C"
kmapharmon6CX chnget "mapharmon6CX"
kmapharmon6F chnget "mapharmon6F"
kmapharmon6FX chnget "mapharmon6FX"
kmapTport chnget "mapTport"
kmapTportX chnget "mapTportX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapharmmix == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 261, 2, 0
            event "i", 261, 0, 999999999
        elseif kmapharmon1C == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 262, 2, 0
            event "i", 262, 0, 999999999
        elseif kmapharmon1F == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 263, 2, 0
            event "i", 263, 0, 999999999
        elseif kmapharmon2C == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 264, 2, 0
            event "i", 264, 0, 999999999
        elseif kmapharmon2F == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 265, 2, 0
            event "i", 265, 0, 999999999
        elseif kmapharmon3C == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 266, 2, 0
            event "i", 266, 0, 999999999
        elseif kmapharmon3F == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 267, 2, 0
            event "i", 267, 0, 999999999
        elseif kmapharmon4C == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 268, 2, 0
            event "i", 268, 0, 999999999
        elseif kmapharmon4F == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 269, 2, 0
            event "i", 269, 0, 999999999
        elseif kmapharmon5C == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 270, 2, 0
            event "i", 270, 0, 999999999
        elseif kmapharmon5F == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 271, 2, 0
            event "i", 271, 0, 999999999
        elseif kmapharmon6C == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 272, 2, 0
            event "i", 272, 0, 999999999
        elseif kmapharmon6F == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 273, 2, 0
            event "i", 273, 0, 999999999
        elseif kmapTport == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 274, 2, 0
            event "i", 274, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapharmmixX == 1 then
    turnoff2 261, 2, 0
elseif kmapharmon1CX == 1 then
    turnoff2 262, 2, 0
elseif kmapharmon1FX == 1 then
    turnoff2 263, 2, 0
elseif kmapharmon2CX == 1 then
    turnoff2 264, 2, 0
elseif kmapharmon2FX == 1 then
    turnoff2 265, 2, 0
elseif kmapharmon3CX == 1 then
    turnoff2 266, 2, 0
elseif kmapharmon3FX == 1 then
    turnoff2 267, 2, 0
elseif kmapharmon4CX == 1 then
    turnoff2 268, 2, 0
elseif kmapharmon4FX == 1 then
    turnoff2 269, 2, 0
elseif kmapharmon5CX == 1 then
    turnoff2 270, 2, 0
elseif kmapharmon5FX == 1 then
    turnoff2 271, 2, 0
elseif kmapharmon6CX == 1 then
    turnoff2 272, 2, 0
elseif kmapharmon6FX == 1 then
    turnoff2 273, 2, 0
elseif kmapTportX == 1 then
    turnoff2 274, 2, 0
endif
endin

instr 261 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmmix"
endin

instr 262 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon1C"
endin

instr 263 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon1F"
endin

instr 264 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon2C"
endin

instr 265 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon2F"
endin

instr 266 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon3C"
endin

instr 267 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon3F"
endin

instr 268 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon4C"
endin

instr 269 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon4F"
endin

instr 270 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon5C"
endin

instr 271 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon5F"
endin

instr 272 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon6C"
endin

instr 273 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon6F"
endin

instr 274 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,5 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Tport"
endin

instr 280
;receive MIDI mapping buttons for Chorus
kmapchmix chnget "mapchmix"
kmapchmixX chnget "mapchmixX"
kmapchcps chnget "mapchcps"
kmapchcpsX chnget "mapchcpsX"
kmapchFB chnget "mapchFB"
kmapchFBX chnget "mapchFBX"
kmapchdepth chnget "mapchdepth"
kmapchdepthX chnget "mapchdepthX"
kmapchdel chnget "mapchdel"
kmapchdelX chnget "mapchdelX"
kmapchrand chnget "mapchrand"
kmapchrandX chnget "mapchrandX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapchmix == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 281, 2, 0
            event "i", 281, 0, 999999999
        elseif kmapchcps == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 282, 2, 0
            event "i", 282, 0, 999999999
        elseif kmapchFB == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 283, 2, 0
            event "i", 283, 0, 999999999
        elseif kmapchdepth == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 284, 2, 0
            event "i", 284, 0, 999999999
        elseif kmapchdel == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 285, 2, 0
            event "i", 285, 0, 999999999
        elseif kmapchrand == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 286, 2, 0
            event "i", 286, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapchmixX == 1 then
    turnoff2 281, 2, 0
elseif kmapchcpsX == 1 then
    turnoff2 282, 2, 0
elseif kmapchFBX == 1 then
    turnoff2 283, 2, 0
elseif kmapchdepthX == 1 then
    turnoff2 284, 2, 0
elseif kmapchdelX == 1 then
    turnoff2 285, 2, 0
elseif kmapchrandX == 1 then
    turnoff2 286, 2, 0
endif
endin

instr 281 ;MIDI mapping for Chorus
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "chmix"
endin

instr 282 ;MIDI mapping for Chorus
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,25 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "chcps"
endin

instr 283 ;MIDI mapping for Chorus
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.999 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "chFB"
endin

instr 284 ;MIDI mapping for Chorus
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.1,50 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "chdepth"
endin

instr 285 ;MIDI mapping for Chorus
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.1,50 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "chdel"
endin

instr 286 ;MIDI mapping for Chorus
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.9 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "chrand"
endin

instr 290
;receive MIDI mapping buttons for Delay
kmapdeltime chnget "mapdeltime"
kmapdeltimeX chnget "mapdeltimeX"
kmapdelFB chnget "mapdelFB"
kmapdelFBX chnget "mapdelFBX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapdeltime == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 291, 2, 0
            event "i", 291, 0, 999999999
        elseif kmapdelFB == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 292, 2, 0
            event "i", 292, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapdeltimeX == 1 then
    turnoff2 291, 2, 0
elseif kmapdelFBX == 1 then
    turnoff2 292, 2, 0
endif
endin

instr 291 ;MIDI mapping for Delay
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.001,4.99 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "deltime"
endin

instr 292 ;MIDI mapping for Delay
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.99 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "delFB"
endin

instr 300
;receive MIDI mapping buttons for Reverb
kmaprevmix chnget "maprevmix"
kmaprevmixX chnget "maprevmixX"
kmaprevFB chnget "maprevFB"
kmaprevFBX chnget "maprevFBX"
kmaprevLP chnget "maprevLP"
kmaprevLPX chnget "maprevLPX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmaprevmix == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 301, 2, 0
            event "i", 301, 0, 999999999
        elseif kmaprevFB == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 302, 2, 0
            event "i", 302, 0, 999999999
        elseif kmaprevLP == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 303, 2, 0
            event "i", 303, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmaprevmixX == 1 then
    turnoff2 301, 2, 0
elseif kmaprevFBX == 1 then
    turnoff2 302, 2, 0
elseif kmaprevLPX == 1 then
    turnoff2 303, 2, 0
endif
endin

instr 301 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "revmix"
endin

instr 302 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,.999 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "revFB"
endin

instr 303 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,200,20000 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "revLP"
endin

instr 400   ;FFT FX 
aL=gasrcL
aR=gasrcR

kshifton chnget "shifton"
if kshifton==0 goto noshift
  ktrig	changed	gkshiftsize
  if ktrig==1 then
   reinit shift
  endif
shift:
ishiftsize=giFFTSizes[i(gkshiftsize)]
kshift chnget "shift"
kshift portk kshift,.1
klowest chnget "lowest"
klowest portk klowest,.1
kshiftmix chnget "shiftmix"
fshiftanalL pvsanal aL,ishiftsize,ishiftsize*.25,ishiftsize,0
fshiftanalR pvsanal aR,ishiftsize,ishiftsize*.25,ishiftsize,0
fshiftL pvshift fshiftanalL,kshift*ishiftsize,klowest*ishiftsize
fshiftR pvshift fshiftanalR,kshift*ishiftsize,klowest*ishiftsize
ashiftL pvsynth fshiftL
ashiftR pvsynth fshiftR
aL=(ashiftL*kshiftmix)+(aL*(1-kshiftmix))
aR=(ashiftR*kshiftmix)+(aR*(1-kshiftmix))    

noshift:
kwarpon chnget "warpon"
if kwarpon==0 goto nowarp
  ktrig	changed	gkwarpsize
  if ktrig==1 then
   reinit warp
  endif
warp:
iwarpsize=giFFTSizes[i(gkwarpsize)]
kenvscale chnget "envscale"
kenvscale portk kenvscale,.1
kenvshift chnget "envshift"
kenvshift portk kenvshift,.1
kenvlowest chnget "envlowest"
kenvlowest portk kenvlowest,.1
kwarpmix chnget "warpmix"
fwarpanalL pvsanal aL,iwarpsize,iwarpsize*.25,iwarpsize,0
fwarpanalR pvsanal aR,iwarpsize,iwarpsize*.25,iwarpsize,0
fwarpL pvswarp fwarpanalL,kenvshift*iwarpsize,kenvscale*iwarpsize,kenvlowest*(sr*.5*iwarpsize)
fwarpR pvswarp fwarpanalR,kenvshift*iwarpsize,kenvscale*iwarpsize,kenvlowest*(sr*.5*iwarpsize)
awarpL pvsynth fwarpL
awarpR pvsynth fwarpR
aL=(awarpL*kwarpmix)+(aL*(1-kwarpmix))
aR=(awarpR*kwarpmix)+(aR*(1-kwarpmix))    

nowarp:
ksmoothon chnget "smoothon"
if ksmoothon==0 goto nosmooth
  ktrig	changed	gksmoothsize
  if ktrig==1 then
   reinit smooth
  endif
smooth:
ismoothsize=giFFTSizes[i(gksmoothsize)]
kampsmooth chnget "ampsmooth"
kfreqsmooth chnget "freqsmooth"
ksmoothmix chnget "smoothmix"
fsmoothanalL pvsanal aL,ismoothsize,ismoothsize*.25,ismoothsize,0
fsmoothanalR pvsanal aR,ismoothsize,ismoothsize*.25,ismoothsize,0
fsmoothL pvsmooth fsmoothanalL,1-kampsmooth,1-kfreqsmooth
fsmoothR pvsmooth fsmoothanalR,1-kampsmooth,1-kfreqsmooth
asmoothL pvsynth fsmoothL
asmoothR pvsynth fsmoothR
aL=(asmoothL*ksmoothmix)+(aL*(1-ksmoothmix))
aR=(asmoothR*ksmoothmix)+(aR*(1-ksmoothmix)) 

nosmooth:
karpon chnget "arpon"
if karpon==0 goto noarp
  ktrig	changed	gkarpsize
  if ktrig==1 then
   reinit arp
  endif
arp:
iarpsize=giFFTSizes[i(gkarpsize)]
karpbin1 chnget "arpbin1"
karpbin2 chnget "arpbin2"
karpbin3 chnget "arpbin3"
karpdepth1 chnget "karpdepth1"
karpdepth2 chnget "karpdepth2"
karpdepth3 chnget "karpdept3"
karpgain1 chnget "arpgain1"
karpgain2 chnget "arpgain2"
karpgain3 chnget "arpgain3"
karpwidth1 chnget "arpwidth1"
karpwidth2 chnget "arpwidth2"
karpwidth3 chnget "arpwidth3"
karpspeed1 chnget "arpspeed1"
karpspeed2 chnget "arpspeed2"
karpspeed3 chnget "arpspeed3"
karpamp1 chnget "arpamp1"
karpamp2 chnget "arpamp2"
karpamp3 chnget "arpamp3"
kshape1 chnget "arpshape1"
kshape2 chnget "arpshape2"
kshape3 chnget "arpshape3"
krand1 chnget "arprand1"
krand2 chnget "arprand2"
krand3 chnget "arprand3"
karpmix chnget "arpmix"

krandom1 randi karpspeed1*krand1,karpspeed1
kspeed1=karpspeed1+krandom1
krandom2 randi karpspeed2*krand2,karpspeed2
kspeed2=karpspeed2+krandom2
krandom3 randi karpspeed3*krand3,karpspeed3
kspeed3=karpspeed3+krandom3

if kshape1 = 1 then
kbin1a oscili karpwidth1,kspeed1,25
elseif kshape1 = 2 then 
kbin1a oscili karpwidth1,kspeed1,30
elseif kshape1 = 3 then 
kbin1a oscili karpwidth1,kspeed1,31
elseif kshape1 = 4 then 
kbin1a oscili karpwidth1,kspeed1,32
elseif kshape1 = 5 then 
kbin1a oscili karpwidth1,kspeed1,33
elseif kshape1 = 6 then 
kbin1a oscili karpwidth1,kspeed1,34
elseif kshape1 = 7 then 
kbin1a randh karpwidth1,kspeed1
elseif kshape1 = 8 then 
kbin1a randi karpwidth1,kspeed1
endif
kbin1=karpbin1+kbin1a

if kshape2 = 1 then
kbin2a oscili karpwidth2,kspeed2,25
elseif kshape2 = 2 then 
kbin2a oscili karpwidth2,kspeed2,30
elseif kshape2 = 3 then 
kbin2a oscili karpwidth2,kspeed2,31
elseif kshape2 = 4 then 
kbin2a oscili karpwidth2,kspeed2,32
elseif kshape2 = 5 then 
kbin2a oscili karpwidth2,kspeed2,33
elseif kshape2 = 6 then 
kbin2a oscili karpwidth2,kspeed2,34
elseif kshape2 = 7 then 
kbin2a randh karpwidth2,kspeed2
elseif kshape2 = 8 then 
kbin2a randi karpwidth2,kspeed2
endif
kbin2=karpbin2+kbin2a

if kshape3 = 1 then
kbin3a oscili karpwidth3,kspeed3,25
elseif kshape3 = 2 then 
kbin3a oscili karpwidth3,kspeed3,30
elseif kshape3 = 3 then 
kbin3a oscili karpwidth3,kspeed3,31
elseif kshape3 = 4 then 
kbin3a oscili karpwidth3,kspeed3,32
elseif kshape3 = 5 then 
kbin3a oscili karpwidth3,kspeed3,33
elseif kshape3 = 6 then 
kbin3a oscili karpwidth3,kspeed3,34
elseif kshape3 = 7 then 
kbin3a randh karpwidth3,kspeed3
elseif kshape3 = 8 then 
kbin3a randi karpwidth3,kspeed3
endif
kbin3=karpbin3+kbin3a

farpanalL pvsanal aL,iarpsize,iarpsize*.25,iarpsize,0
farpanalR pvsanal aR,iarpsize,iarpsize*.25,iarpsize,0
farp1L pvsarp farpanalL,kbin1,karpdepth1,karpgain1
farp1R pvsarp farpanalR,kbin1,karpdepth1,karpgain1
farp2L pvsarp farpanalL,kbin2,karpdepth2,karpgain2
farp2R pvsarp farpanalR,kbin2,karpdepth2,karpgain2
farp3L pvsarp farpanalL,kbin3,karpdepth3,karpgain3
farp3R pvsarp farpanalR,kbin3,karpdepth3,karpgain3
arp1L pvsynth farp1L
arp1R pvsynth farp1R
arp2L pvsynth farp2L
arp2R pvsynth farp2R
arp3L pvsynth farp3L
arp3R pvsynth farp3R
arpLsum=(arp1L*karpamp1)+(arp2L*karpamp2)+(arp3L*karpamp3)
arpRsum=(arp1R*karpamp1)+(arp2R*karpamp2)+(arp3R*karpamp3)
arpL balance arpLsum,aL
arpR balance arpRsum,aR
aL=(arpL*karpmix)+(aL*(1-karpmix))
aR=(arpR*karpmix)+(aR*(1-karpmix)) 

noarp:

gasrcL=aL;+gasrcL
gasrcR=aR;+gasrcR

endin

instr 500   ;global FX for EQ, distortion, LP, Phaser, Flanger, etc
aL=gasrcL
aR=gasrcR

;distortion
kdiston chnget "diston"
if kdiston==0 goto nodist
kdist chnget "distA"
kdist port kdist,.05
ad1L distort aL,kdist,26
ad1R distort aR,kdist,26
aL balance2 ad1L,aL
aR balance2 ad1R,aR

kdist2 chnget "distB"
kdist2=1-kdist2
kdist2 port kdist2,.05
ad2L powershape aL,kdist2
ad2R powershape aR,kdist2
aL balance2 ad2L,aL
aR balance2 ad2R,aR

kdist3 chnget "distC"
kdist3 port kdist3,.05
ad3L fold aL,kdist3
ad3R fold aR,kdist3
aL balance2 ad3L,aL
aR balance2 ad3R,aR

nodist:
;LP filter
kLPon chnget "LPon"
if kLPon==0 goto noLP
kLPsel chnget "LPsel"
kLPcps chnget "LPcps"
kLPcps port kLPcps,.1
kLPcfr chnget "LPcfr"
kLPcfd chnget "LPcfd"
kLPcfrand chnget "LPrand"
kLPres chnget "LPres"
kLPresr chnget "LPresr"
kLPresd chnget "LPresd"
kLPjit jitter kLPcfr*kLPcfrand,3,11
kLPcf oscili kLPcfd,kLPcfr+kLPjit,25
kLPQ oscili kLPresd,kLPresr,25
a1L,a2L,a3L,a4L mvclpf4 aL,cpsoct(kLPcf+kLPcps),kLPQ+kLPres
a1R,a2R,a3R,a4R mvclpf4 aR,cpsoct(kLPcf+kLPcps),kLPQ+kLPres
if kLPsel=1 then
alpL=a1L
alpR=a1R
elseif kLPsel=2 then
alpL=a2L
alpR=a2R
elseif kLPsel=3 then
alpL=a3L
alpR=a3R
elseif kLPsel=4 then
alpL=a4L
alpR=a4R
endif
aL balance alpL,aL
aR balance alpR,aR

noLP:
;4 Parallel Filters
kparon chnget "paron"
kfport chnget "fport"
if kparon==0 goto nopar
kparsel1 chnget "parsel1"
kparsel2 chnget "parsel2"
kparsel3 chnget "parsel3"
kparsel4 chnget "parsel4"
kparF1 chnget "parF1"
kparF2 chnget "parF2"
kparF3 chnget "parF3"
kparF4 chnget "parF4"
kparF1 portk kparF1,kfport
kparF2 portk kparF2,kfport
kparF3 portk kparF3,kfport
kparF4 portk kparF4,kfport
kparcfr1 chnget "parcfr1"
kparcfr2 chnget "parcfr2"
kparcfr3 chnget "parcfr3"
kparcfr4 chnget "parcfr4"
kparcfd1 chnget "parcfd1"
kparcfd2 chnget "parcfd2"
kparcfd3 chnget "parcfd3"
kparcfd4 chnget "parcfd4"
kparcfrnd1 chnget "parcfrnd1"
kparcfrnd2 chnget "parcfrnd2"
kparcfrnd3 chnget "parcfrnd3"
kparcfrnd4 chnget "parcfrnd4"
kparres1 chnget "parres1"
kparres2 chnget "parres2"
kparres3 chnget "parres3"
kparres4 chnget "parres4"
kparres1 portk kparres1,kfport
kparres2 portk kparres2,kfport
kparres3 portk kparres3,kfport
kparres4 portk kparres4,kfport
kparamp1 chnget "paramp1"
kparamp2 chnget "paramp2"
kparamp3 chnget "paramp3"
kparamp4 chnget "paramp4"
kparamp1 portk kparamp1,kfport
kparamp2 portk kparamp2,kfport
kparamp3 portk kparamp3,kfport
kparamp4 portk kparamp4,kfport
kparjit1 jitter kparcfr1*kparcfrnd1,2.5,8
kparjit2 jitter kparcfr2*kparcfrnd2,3.5,11
kparjit3 jitter kparcfr3*kparcfrnd3,3,10
kparjit4 jitter kparcfr4*kparcfrnd4,2.1,9
kpardev1 oscili kparcfd1,kparcfr1+kparjit1,25
kpardev2 oscili kparcfd2,kparcfr2+kparjit2,25
kpardev3 oscili kparcfd3,kparcfr3+kparjit3,25
kpardev4 oscili kparcfd4,kparcfr4+kparjit4,25
a1lpL,a1bpL,a1hpL zdf_2pole_mode aL,cpsoct(kparF1+kpardev1),kparres1
a1lpR,a1bpR,a1hpR zdf_2pole_mode aR,cpsoct(kparF1+kpardev1),kparres1
a2lpL,a2bpL,a2hpL zdf_2pole_mode aL,cpsoct(kparF2+kpardev2),kparres2
a2lpR,a2bpR,a2hpR zdf_2pole_mode aR,cpsoct(kparF2+kpardev2),kparres2
a3lpL,a3bpL,a3hpL zdf_2pole_mode aL,cpsoct(kparF3+kpardev3),kparres3
a3lpR,a3bpR,a3hpR zdf_2pole_mode aR,cpsoct(kparF3+kpardev3),kparres3
a4lpL,a4bpL,a4hpL zdf_2pole_mode aL,cpsoct(kparF4+kpardev4),kparres4
a4lpR,a4bpR,a4hpR zdf_2pole_mode aR,cpsoct(kparF4+kpardev4),kparres4
if kparsel1=1 then
apar1L=a1lpL
apar1R=a1lpR
elseif kparsel1=2 then
apar1L=a1bpL
apar1R=a1bpR
elseif kparsel1=3 then
apar1L=a1hpL
apar1R=a1hpR
elseif kparsel1=4 then
apar1L=0
apar1R=0
endif
if kparsel2=1 then
apar2L=a2lpL
apar2R=a2lpR
elseif kparsel2=2 then
apar2L=a2bpL
apar2R=a2bpR
elseif kparsel2=3 then
apar2L=a2hpL
apar2R=a2hpR
elseif kparsel2=4 then
apar2L=0
apar2R=0
endif
if kparsel3=1 then
apar3L=a3lpL
apar3R=a3lpR
elseif kparsel3=2 then
apar3L=a3bpL
apar3R=a3bpR
elseif kparsel3=3 then
apar3L=a3hpL
apar3R=a3hpR
elseif kparsel3=4 then
apar3L=0
apar3R=0
endif
if kparsel3=1 then
apar4L=a4lpL
apar4R=a4lpR
elseif kparsel4=2 then
apar4L=a4bpL
apar4R=a4bpR
elseif kparsel4=3 then
apar4L=a4hpL
apar4R=a4hpR
elseif kparsel4=4 then
apar4L=0
apar4R=0
endif
aparsumL=(apar1L*kparamp1)+(apar2L*kparamp2)+(apar3L*kparamp3)+(apar4L*kparamp4)
aparsumR=(apar1R*kparamp1)+(apar2R*kparamp2)+(apar3R*kparamp3)+(apar4R*kparamp4)
aL balance aparsumL,aL
aR balance aparsumR,aR

nopar:
;phaser
kphson chnget "phson"
if kphson==0 goto nophaser
kphscps chnget "phscps"
kphsQ chnget "phsQ"
kphsFB chnget "phsFB"
kphsdev oscil 25,kphscps,25
aLphs phaser2 aL,100+kphsdev,kphsQ,20,1,1,kphsFB
aRphs phaser2 aR,100+kphsdev,kphsQ,20,1,1,kphsFB
aL=(aL+aLphs)*.5
aR=(aR+aRphs)*.5

nophaser:
;flanger
kflon chnget "flon"
if kflon==0 goto noflanger
kflcps chnget "flcps"
kflFB chnget "flFB"
adel oscil .02,kflcps,27
aLfl flanger aL,adel*.05,kflFB,.1
aLfl clip aLfl,1,1
aRfl flanger aR,adel*.05,kflFB,.1
aRfl clip aRfl,1,1
aL=(aL+aLfl)*.5
aR=(aR+aRfl)*.5

noflanger:
;global transposer with 6 voices
kton chnget "ton"
if kton==0 goto noharmon
  ktrig	changed	gkTsize
  if ktrig==1 then
   reinit transposer
  endif
transposer:
iTsize=giFFTSizes[i(gkTsize)]

kharmon1 chnget "harmon1" ;on/off button
kharmon2 chnget "harmon2"
kharmon3 chnget "harmon3"
kharmon4 chnget "harmon4"
kharmon5 chnget "harmon5"
kharmon6 chnget "harmon6"
kharm1 port kharmon1,.05
kharm2 port kharmon2,.05
kharm3 port kharmon3,.05
kharm4 port kharmon4,.05
kharm5 port kharmon5,.05
kharm6 port kharmon6,.05

kTport chnget "Tport"
kT1C chnget "harmon1C"
kT1F chnget "harmon1F"
kT2C chnget "harmon2C"
kT2F chnget "harmon2F"
kT3C chnget "harmon3C"
kT3F chnget "harmon3F"
kT4C chnget "harmon4C"
kT4F chnget "harmon4F"
kT5C chnget "harmon5C"
kT5F chnget "harmon5F"
kT6C chnget "harmon6C"
kT6F chnget "harmon6F"
kT1C portk kT1C,kTport
kT1F portk kT1F,kTport
kT2C portk kT2C,kTport
kT2F portk kT2F,kTport
kT3C portk kT3C,kTport
kT3F portk kT3F,kTport
kT4C portk kT4C,kTport
kT4F portk kT4F,kTport
kT5C portk kT5C,kTport
kT5F portk kT5F,kTport
kT6C portk kT6C,kTport
kT6F portk kT6F,kTport

kshift1=kT1C+kT1F
kshift2=kT2C+kT2F
kshift3=kT3C+kT3F
kshift4=kT4C+kT4F
kshift5=kT5C+kT5F
kshift6=kT6C+kT6F
kharmmix chnget "harmmix"
ibase=cpsoct(8) ;middle C as base frequency

kratio1=cpsoct(8+(kshift1/12))/ibase ;Transposition ratio
kratio2=cpsoct(8+(kshift2/12))/ibase 
kratio3=cpsoct(8+(kshift3/12))/ibase 
kratio4=cpsoct(8+(kshift4/12))/ibase 
kratio5=cpsoct(8+(kshift5/12))/ibase 
kratio6=cpsoct(8+(kshift6/12))/ibase 

kjit1 jitter .002,.75,3.7
kjit2 jitter .001,.15,2.11
kjit3 jitter .0023,.1,1.4
kjit4 jitter .0025,.4,4.7
kjit5 jitter .0016,.6,3.8
kjit6 jitter .0019,.31,5.6

kratio1=kratio1+kjit1
kratio2=kratio2+kjit2
kratio3=kratio3+kjit3
kratio4=kratio4+kjit4
kratio5=kratio5+kjit5
kratio6=kratio6+kjit6

fftinL pvsanal aL,iTsize,iTsize*.25,iTsize,1
fftinR pvsanal aR,iTsize,iTsize*.25,iTsize,1

fftT1L pvscale fftinL,kratio1 ;pitch scaling and resynthesis
fftT1R pvscale fftinR,kratio1
aT1L pvsynth fftT1L
aT1R pvsynth fftT1R

fftT2L pvscale fftinL,kratio2
fftT2R pvscale fftinR,kratio2
aT2L pvsynth fftT2L
aT2R pvsynth fftT2R

fftT3L pvscale fftinL,kratio3
fftT3R pvscale fftinR,kratio3
aT3L pvsynth fftT3L
aT3R pvsynth fftT3R

fftT4L pvscale fftinL,kratio4
fftT4R pvscale fftinR,kratio4
aT4L pvsynth fftT4L
aT4R pvsynth fftT4R

fftT5L pvscale fftinL,kratio5
fftT5R pvscale fftinR,kratio5
aT5L pvsynth fftT5L
aT5R pvsynth fftT5R

fftT6L pvscale fftinL,kratio6
fftT6R pvscale fftinR,kratio6
aT6L pvsynth fftT6L
aT6R pvsynth fftT6R

asumL=(aT1L*kharm1)+(aT2L*kharm2)+(aT3L*kharm3)+(aT4L*kharm4)+(aT5L*kharm5)+(aT6L*kharm6)
asumR=(aT1R*kharm1)+(aT2R*kharm2)+(aT3R*kharm3)+(aT4R*kharm4)+(aT5R*kharm5)+(aT6R*kharm6)
aL=(aL*(1-kharmmix))+(asumL*kharmmix)
aR=(aR*(1-kharmmix))+(asumR*kharmmix)

noharmon:
gaFXL=aL
gaFXR=aR

endin

;does global harmonizer with 6 voices need to be its own instrument here?

instr 502   ;global chorus
kchon chnget "chon"
kchmix chnget "chmix"
kchFB chnget "chFB"
kchdepth chnget "chdepth"
kchcps chnget "chcps"
kchrand chnget "chrand"
kchdel chnget "chdel"
if kchon==0 goto NOCHOR
achorusFBL init 0
achorusFBR init 0
afeedL=gaFXL+achorusFBL
afeedR=gaFXR+achorusFBR
kdepthrand=kchdepth*kchrand*.001
kchdel=kchdel*.001
kcpsrand=kchcps*kchrand
kchcps randomi kchcps-kcpsrand,kchcps+kcpsrand,kchcps
kchdepth randomi kchdepth-kdepthrand,kchdepth+kdepthrand,kchcps
kchdepth port kchdepth,.1
ardelL oscili kchdepth,kchcps,25
ardelR oscili kchdepth,kchcps,25,.25
ardel3 oscili kchdepth,kchcps,25,.5
ardel4 oscili kchdepth,kchcps,25,.75
ardelL=ardelL+(kchdepth*2.1+kchdel)
ardelR=ardelR+(kchdepth*2.1+kchdel)
ardel3=ardel3+(kchdepth*2.1+kchdel)
ardel4=ardel4+(kchdepth*2.1+kchdel)
amodL vdelay afeedL,ardelL,200
amodR vdelay afeedR,ardelR,200
amod3 vdelay afeedL*.33+afeedR*.66,ardel3,200
amod4 vdelay afeedR*.33+afeedL*.66,ardel4,200
achorusFBL=dcblock(((amodL*.6)+(amod4*.3)+(amod3*.15))*-kchFB)
achorusFBR=dcblock(((amodR*.6)+(amod3*.3)+(amod4*.15))*-kchFB)
gaChorL=((afeedL*.7+amodL)*kchmix)+((1-kchmix)*gaFXL)
gaChorR=((afeedR*.7+amodR)*kchmix)+((1-kchmix)*gaFXR)
goto LAST
NOCHOR:
gaChorL=gaFXL
gaChorR=gaFXR
LAST:
endin

instr 505   ;global FB delay FX
kdelon chnget "delon"
if kdelon==0 goto NODEL
aFBL init 0
aFBR init 0
kdel chnget "deltime"
kdel port kdel,.05
adel interp kdel*1000
kDelFB chnget "delFB"
aLdel vdelay gaChorL+aFBL,adel,5000
aRdel vdelay gaChorR+aFBR,adel,5000
aFBL=dcblock((aLdel*kDelFB)+gaChorL)
aFBR=dcblock((aRdel*kDelFB)+gaChorR)
gaDelL=aFBL
gaDelR=aFBR
goto LAST
NODEL:
gaDelL=gaChorL
gaDelR=gaChorR
LAST:
endin

instr 510   ;global reverb, always on
krevon chnget "revon"
if krevon==0 goto NOREV
krevmix chnget "revmix"
krevmix port krevmix,.05
krevFB chnget "revFB"
krevLP chnget "revLP"
aLrev,aRrev reverbsc gaDelL,gaDelR,krevFB,krevLP,sr,.075 ;don't need these to be global
gafinalL=(gaDelL*(1-krevmix))+(aLrev*krevmix)
gafinalR=(gaDelR*(1-krevmix))+(aRrev*krevmix)
goto FINALOUT
NOREV:
gafinalL=gaDelL
gafinalR=gaDelR
FINALOUT:
outs gafinalL,gafinalR
endin

instr 600	; record file
irecch chnget "recch"
ibit chnget "bit"
 print	p1
 if gkplay==1 then
  chnset	k(0),"record"
  turnoff
 endif
 gkFileRecorded		init	1
 itim     date
 Stim     dates     itim
 itim     date
 Stim     dates     itim
 Syear    strsub    Stim, 20, 24
 Smonth   strsub    Stim, 4, 7
 Sday     strsub    Stim, 8, 10
 iday     strtod    Sday
 Shor     strsub    Stim, 11, 13
 Smin     strsub    Stim, 14, 16
 Ssec     strsub    Stim, 17, 19
 Sfilnam  sprintf  "%s_%s_%02d_%s_%s_%s.wav", Syear, Smonth, iday, Shor,Smin, Ssec
 gSname   sprintf "ReSynthesizer_%s", Sfilnam
 if gkrecord==1 then			; record
  if ibit=1 then
   imode=4
  elseif ibit=2 then
   imode=8
  elseif ibit=3 then
   imode=5
  endif
  if irecch=1 then
   fout gSname,imode,(gafinalL+gafinalR)*.7
  elseif irecch=2 then
   fout gSname,imode,gafinalL, gafinalR
  endif
 endif
 gkRecordingActiveFlag	=	1 - release()
endin

instr	601	; play file
 if gkplay==0 then
  turnoff
 endif 
   aL,aR	diskin2	gSname,1
  	outs	aL,aR
 iFileLen	filelen	gSname
 p3	=	iFileLen
 xtratim	0.1 
 krelease	release
 	chnset	1-krelease,"play"
endin

instr 750   ;clear global audio paths that include feedback (don't need to clear the global LFO outputs)
clear   gasrcL,gasrcR,gaFFTL,gaFFTR,gaChorL,gaChorR,gaDelL,gaDelR,gaFXL,gaFXR,gafinalL,gafinalR
endin

</CsInstruments>
<CsScore>
f1 0 16385 10 1 ;sine with wrap-around guard point for foscil
f2 0 16384 11 1 ;cpsine for gbuzz
f25 0 8193 10 1 ;sine for LFOs
f26 0 8193 7 -1 3500 -1 1193 1 3500 1   ;for distort opcode waveshaping
f27 0 16385 7 0 8192 1 8193 0   ;used to control flanger delay
f28 0 8193 10 1 0 .333 0 .2 0 .144 0 .1111 ;square wave
f29 0 8193 20 3 ;triangle envelope for harmonizer
f30 0 8193 7 0 2048 1 4097 -1 2048 0 ;triangle for arp
f31 0 8193 7 1 4096 1 0 -1 4097 -1 ;square for arp
f32 0 8193 7 0 8193 1 ;ramp up for arp
f33 0 8193 7 0 8193 -1 ;ramp down for arp
f34 0 8193 10 1 1 1 1 1 1 1 1 1 1 .9 .7 .5 .3 .1 ;pulse for arp

;causes Csound to run for about 7000 years...
i1 0 999999
i25 0 999999
i60 0 999999 ;vocal formant parallel filter preset control
i61 0 999999 ;Transposer preset control
i100 0 999999
i110 0 999999
i120 0 999999
i130 0 999999
i150 0 999999
i160 0 999999
i210 0 999999
i230 0 999999
i240 0 999999
i250 0 999999
i260 0 999999
i280 0 999999
i290 0 999999
i300 0 999999
i320 0 999999
i340 0 999999
i350 0 999999
i360 0 999999
i400 0 999999
i500 0 999999
i502 0 999999
i505 0 999999
i510 0 999999
i750 0 999999
</CsScore>
</CsoundSynthesizer>
